searchData={"items":[{"type":"module","title":"LiveViewNative.SwiftUI.UtilityStyles","doc":"Tailwind-style utility classes for LiveView Native.","ref":"LiveViewNative.SwiftUI.UtilityStyles.html"},{"type":"module","title":"Modifier Translation - LiveViewNative.SwiftUI.UtilityStyles","doc":"Modifiers can easily be translated to classes.\n\n1. Separate any arguments with a dash (`-`)\n2. Use labels for any named arguments (`key:value`)\n\n| Modifier | Class |\n| -------- | ----- |\n| `padding(.leading, 32)` | `padding-leading-32` |\n| `frame(width: 100, height: 100)` | `frameWidth:100-height:100` |\n| `buttonStyle(.borderedProminent)` | `buttonStyle-borderedProminent` |","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#module-modifier-translation"},{"type":"module","title":"Attribute References - LiveViewNative.SwiftUI.UtilityStyles","doc":"To reference an attribute value, use `[attr(attribute-name)]`:\n\n```html\n \n```","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#module-attribute-references"},{"type":"module","title":"Complex Arguments - LiveViewNative.SwiftUI.UtilityStyles","doc":"Complex types (such as a gradient `ShapeStyle`) can be provided by writing out the full syntax as an argument.\n\n```html\n \n \n```\n\n> [!NOTE]\n> Spaces cannot be used within class names.","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#module-complex-arguments"},{"type":"module","title":"Spaces and Underscores - LiveViewNative.SwiftUI.UtilityStyles","doc":"To include a space in a string argument, use and underscore `['Hello,_world!']`.\nAny underscores will be replaced with a space.\n\n```html\n \n```\n\nIf you need to include an underscore character, escape it with `_`.\n\n```html\n \n```","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#module-spaces-and-underscores"},{"type":"module","title":"Shorthand - LiveViewNative.SwiftUI.UtilityStyles","doc":"Some aliases are provided to make common classes easier to use.\n\n| Alias | Expansion |\n| ----- | --------- |\n| `px` | `padding-horizontal` |\n| `py` | `padding-vertical` |\n| `pt` | `padding-top` |\n| `pr` | `padding-trailing` |\n| `pb` | `padding-bottom` |\n| `pl` | `padding-leading` |\n| `pl` | `padding-leading` |\n| `p` | `padding` |\n| `w-` | `frame-width:` |\n| `h-` | `frame-height:` |\n| `min-w-` | `frame-minWidth:` |\n| `max-w-` | `frame-maxWidth:` |\n| `min-h-` | `frame-minHeight:` |\n| `max-h-` | `frame-maxHeight:` |\n| `fg` | `foregroundStyle` |\n| `bg` | `background` |\n| `overlay--` | `overlay-content::` |\n| `bg--` | `background-content::` |\n| `mask--` | `mask-mask::` |\n| `toolbar--` | `toolbar-content::` |\n| `safe-area-inset--` | `safeAreaInset-content::` |","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#module-shorthand"},{"type":"function","title":"LiveViewNative.SwiftUI.UtilityStyles.class/1","doc":"","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#class/1"},{"type":"function","title":"LiveViewNative.SwiftUI.UtilityStyles.parse/2","doc":"","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#parse/2"},{"type":"function","title":"LiveViewNative.SwiftUI.UtilityStyles.parse_arguments/1","doc":"","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#parse_arguments/1"},{"type":"macro","title":"LiveViewNative.SwiftUI.UtilityStyles.sigil_RULES/2","doc":"","ref":"LiveViewNative.SwiftUI.UtilityStyles.html#sigil_RULES/2"},{"type":"task","title":"mix lvn.swiftui.gen","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.html"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.files_to_be_generated/1","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.html#files_to_be_generated/1"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.run/1","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.html#run/1"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.switches/0","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.html#switches/0"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.validate_args!/1","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.html#validate_args!/1"},{"type":"task","title":"mix lvn.swiftui.gen.docs","doc":"Generates ex doc files for all SwiftUI views","ref":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.html"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.cheatsheet/1","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.html#cheatsheet/1"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.cheatsheet/2","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.html#cheatsheet/2"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.markdown/1","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.html#markdown/1"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.markdown/2","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.html#markdown/2"},{"type":"function","title":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.run/1","doc":"","ref":"Mix.Tasks.Lvn.Swiftui.Gen.Docs.html#run/1"},{"type":"extras","title":"LiveViewNative","doc":"# LiveViewNative\n\n> #### Client Spec {: .info}\n>\n> format: `:swiftui`\n>\n> module_suffix: `SwiftUI`\n>\n> template_sigil: `~LVN`\n>\n> component: `LiveViewNative.SwiftUI.Component`\n\nThe LiveViewNative Swift package lets you use Phoenix LiveView to build native iOS apps with SwiftUI.","ref":"readme.html"},{"type":"extras","title":"Installation - LiveViewNative","doc":"1. In Xcode, select *File → Add Packages...*\n2. Enter the package URL `https://github.com/liveview-native/liveview-client-swiftui`\n3. Select *Add Package*","ref":"readme.html#installation"},{"type":"extras","title":"Usage - LiveViewNative","doc":"Create a `LiveView` to connect to a Phoenix server running on `http://localhost:4000`.\n\n```swift\nimport SwiftUI\nimport LiveViewNative\n\nstruct ContentView: View {\n    var body: some View {\n        LiveView(.localhost)\n    }\n}\n```\n\nNow when you start up your app, the LiveView will automatically connect and serve your native app.","ref":"readme.html#usage"},{"type":"extras","title":"Elixir Library - LiveViewNative","doc":"","ref":"readme.html#elixir-library"},{"type":"extras","title":"Installation - LiveViewNative","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `live_view_native_swiftui` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:live_view_native_swiftui, \"~> 0.3.0\"}\n  ]\nend\n```\n\nThen add the `SwiftUI` plugin to your list of LiveView Native plugins:\n\n```elixir\nconfig :live_view_native, plugins: [\n  LiveViewNative.SwiftUI\n]\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - LiveViewNative","doc":"This plugin provides the SwiftUI rendering behavior of a Phoenix LiveView. Start by adding this plugin to a LiveView. We do this with `LiveViewNative.LiveView`:\n\n```elixir\ndefmodule MyAppWeb.HomeLive do\n  use MyAppWeb :live_view\n  use LiveViewNative.LiveView,\n    formats: [:swiftui],\n    layouts: [\n      swiftui: {MyAppWeb.Layouts.SwiftUI, :app}\n    ]\n\nend\n```\n\nthen just like all format LiveView Native rendering components you will create a new module namespaced under the calling module with the `module_suffix` appended:\n\n```elixir\ndefmodule MyAppWeb.HomeLive.SwiftUI do\n  use LiveViewNative.Component,\n    format: :swiftui\n\n  def render(assigns, _interface) do\n    ~LVN\"\"\"\n     Hello, SwiftUI! \n    \"\"\"\n  end\nend\n```\n\nFurther details on additional options and an explanation of template rendering vs using `render/2` are in the LiveView Native docs.\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#usage"},{"type":"extras","title":"Resources - LiveViewNative","doc":"- Browse the [documentation](https://liveview-native.github.io/liveview-client-swiftui/documentation/liveviewnative/) to read about the API.\n- Check out the [ElixirConf '22 chat app](https://github.com/liveview-native/elixirconf_chat) for an example of a complete app.","ref":"readme.html#resources"},{"type":"extras","title":"View Index","doc":"# View Index","ref":"view-index.html"},{"type":"extras","title":"Accessibility - View Index","doc":"{: .col-2}\n### ` `\nTracks changed to the dynamic type size in the current context.\n\n\n\n```heex\n \n   \n \n```\n\n```elixir\ndefmodule MyAppWeb.AccessibilityLive do\n  def handle_event(\"scaled-value-changed\", scaled_value, socket) do\n    {:noreply, assign(socket, scaled_value: scaled_value)}\n  end\nend\n```","ref":"view-index.html#accessibility"},{"type":"extras","title":"Buttons - View Index","doc":"{: .col-2}\n### ` `\n` `, sends events when tapped.\n\n\n\n```heex\n Click Me! \n```\n\n```elixir\ndef handle_event(\"my_event\", %{ \"extra\" => extra }, socket) do\n    {:noreply, assign(socket, value: extra)}\nend\n```\n\n\n\n### ` `\nSends an event with the clipboard’s contents when tapped.\n\n\n\n```heex\n \n```\n\n```elixir\ndef handle_event(\"my_event\", %{ \"value\" => value }, socket) do\n  {:noreply, assign(socket, :pasted_value, hd(value))}\nend\n```","ref":"view-index.html#buttons"},{"type":"extras","title":"Collection Containers - View Index","doc":"{: .col-2}\n### ` `\nPresents rows of elements.\n\n\n\n```heex\n \n    <%= for sport <- @sports do %>\n         <%= sport.name %> \n    <% end %>\n \n```\n\n\n```heex\n \n  ...  \n```\n\n\n```heex\n \n    ...\n \n```\n\n\n\n```heex\n \n    ...\n \n```\n\n```elixir\ndefmodule MyAppWeb.SportsLive do\n    def handle_event(\"on_delete\", %{ \"index\" => index }, socket) do\n        {:noreply, assign(socket, :items, List.delete_at(socket.assigns.items, index))}\n    end\nend\n```\n\n\n\n```heex\n \n    ...\n \n```\n\n```elixir\ndefmodule MyAppWeb.SportsLive do\n    def handle_event(\"on_move\", %{ \"index\" => index, \"destination\" => destination }, socket) do\n        {element, list} = List.pop_at(socket.assigns.sports, index)\n        moved = List.insert_at(list, (if destination > index, do: destination - 1, else: destination), element)\n        {:noreply, assign(socket, :sports, moved)}\n    end\nend\n```\n\n\n\n### ` `\nGroups elements in a container.\n\n\n\n```heex\n \n     Item #1 \n    ...\n \n \n     Item #1 \n    ...\n \n```\n\n\n```heex\n \n     Group #1 \n     Item #1 \n     The first group ends here \n \n \n     Group #2 \n     Item #1 \n     The second group ends here \n \n```\n\n\n```heex\n \n    ...\n \n```\n\n\n\n### ` `\nA container organized by rows and columns.\n\n\n\n\n```heex\n \n     \n         Name \n         Description \n         Length \n     \n     \n         \n             Basketball \n             Players attempt to throw a ball into an elevated basket. \n             48 min \n         \n         \n             Soccer \n             Players attempt to kick a ball into a goal. \n             90 min \n         \n         \n             Football \n             Players attempt to throw a ball into an end zone. \n             60 min \n         \n     \n \n```\n\n\n```heex\n \n    ...\n     \n        <%= for sport <- Enum.sort_by(\n            @sports,\n            fn sport -> sport[hd(@sports_sort_order)[\"id\"]] end,\n            (if hd(@sports_sort_order)[\"order\"], do: &</2, else: &>/2)\n        ) do %>\n             \n                 <%= sport[\"name\"] %> \n                 <%= sport[\"description\"] %> \n                 <%= sport[\"length\"] %> \n             \n        <% end %>\n     \n \n```\n\n\n```heex\n \n    ...\n \n```","ref":"view-index.html#collection-containers"},{"type":"extras","title":"Drawing and Graphics - View Index","doc":"{: .col-2}\n### ` `\nA rectangle with a particular fill color.\n\n\n\n\n```heex\n \n```\n\n\n```heex\n \n```\n\n\n```heex\n \n \n```\n\n\n\n\n### ` `\nCreates a namespace for child elements to use.","ref":"view-index.html#drawing-and-graphics"},{"type":"extras","title":"Forms - View Index","doc":"{: .col-2}\n### ` `\nA container for grouping labeled form controls in a consistent style.\n\n\n\n\n### ` `\nPresents an element with an associated label.\n\n\n\n```heex\n \n     Price \n     $100.00 \n \n```\n\n\n\n```heex\n \n    Price\n \n```","ref":"view-index.html#forms"},{"type":"extras","title":"Grids - View Index","doc":"{: .col-2}\n### ` `\nAlign elements along two dimensions.\n\n\n\n```heex\n \n     \n         Title \n         Description \n     \n     \n         Item #1 \n         The first of many items. \n     \n \n```\n\n\n### ` `\nA row of items in a grid.\n\n\n\n```heex\n \n     \n         Title \n         Description \n     \n     \n         Item #1 \n         The first of many items. \n     \n \n```","ref":"view-index.html#grids"},{"type":"extras","title":"Groups - View Index","doc":"{: .col-2}\n### ` `\nVisual grouping of control elements.\n\n\n\n```heex\n \n     Edit Actions \n     \n         Arrange \n         Update \n         Remove \n     \n \n```\n\n\n### ` `\nAn expandable section of content.\n\n\n\n```heex\n \n     Edit Actions \n     \n         Arrange \n         Update \n         Remove \n     \n \n```\n\n\n```heex\n \n    ...\n \n```\n\n\n### ` `\nA collection of elements.\n\n\n\n```heex\n \n     Orange Button \n     Orange Toggle \n     Orange Slider \n \n```\n\n\n```heex\n \n     \n         1 \n         2 \n         3 \n         4 \n         5 \n         6 \n         7 \n         8 \n         9 \n         10 \n     \n     11 \n \n```\n\n\n\n### ` `\nVisual grouping of elements.\n\n\n\n```heex\n \n     Edit Actions \n     \n         Arrange \n         Update \n         Remove \n     \n \n```\n\n\n```heex\n \n     Arrange \n     Update \n     Remove \n \n```","ref":"view-index.html#groups"},{"type":"extras","title":"Images - View Index","doc":"{: .col-2}\n### ` `\nDisplays an image asynchronously loaded from a URL.\n\n\n```heex\n \n```\n\n\n\n\n\n### ` `\nDisplays an image.\n\n\n\n\n\n```heex\n \n```\n\n\n```heex\n \n \n \n```\n\n\n```heex\n \n  Mountain landscape with a lake in the foreground\n \n```\n\n\n```elixir\n\"heart\" do\n    resizable()\n    symbolRenderingMode(.multicolor)\nend\n```\n\n```heex\n \n```","ref":"view-index.html#images"},{"type":"extras","title":"Indicators - View Index","doc":"{: .col-2}\n### ` `\nDisplays a value within a range.\n\n\n\n```heex\n \n     50% \n     0.5 \n     0 \n     1 \n \n```\n\n\n\n### ` `\nDisplays progress toward a target value.\n\n\n\n```heex\n \n```\n\n\n```heex\n \n \n     Completed Percentage \n     25% \n \n```\n\n\n```heex\n  DateTime.add(5, :minute)}\n/>\n```","ref":"view-index.html#indicators"},{"type":"extras","title":"Lazy Grids - View Index","doc":"{: .col-2}\n### ` `\nGrid that grows horizontally.\n\n\n\n```heex\n \n    <%= for i <- 1..50 do %>\n          Integer.to_string}><%= i %> \n    <% end %>\n \n```\n\n\n\n\n### ` `\nGrid that grows vertically.\n\n\n\n```heex\n \n    <%= for i <- 1..50 do %>\n          Integer.to_string}><%= i %> \n    <% end %>\n \n```","ref":"view-index.html#lazy-grids"},{"type":"extras","title":"Lazy Stacks - View Index","doc":"{: .col-2}\n### ` `\nHorizontal stack that creates Views lazily.\n\n\n\n\n```heex\n \n     \n        <%= for i <- 1..50 do %>\n              Integer.to_string} font=\"largeTitle\"><%= i %> \n        <% end %>\n     \n \n```\n\n\n### ` `\nVertical stack that creates Views lazily.\n\n\n\n\n```heex\n \n     \n        <%= for i <- 1..50 do %>\n              Integer.to_string} font=\"largeTitle\"><%= i %> \n        <% end %>\n     \n \n```","ref":"view-index.html#lazy-stacks"},{"type":"extras","title":"Links - View Index","doc":"{: .col-2}\n### ` `\nOpens a URL when tapped.\n\n\n\n```heex\n \n    Go to  LiveView Native \n \n```\n\n\n\n### ` `\nOpens a system share sheet when tapped.\n\n\n\n```heex\n \n```\n\n\n```heex\n \n     \n         \n         \n     \n \n```\n\n\n```heex\n \n     \n         \n         \n     \n     \n         \n         \n     \n     \n         \n         \n     \n \n```\n\n\n### ` `\nA form element that requests text input on Apple Watch.\n\n\n\n```heex\n \n    What's your favorite color?\n \n```","ref":"view-index.html#links"},{"type":"extras","title":"Menus - View Index","doc":"{: .col-2}\n### ` `\nTappable element that expands to reveal a list of options.\n\n\n\n```heex\n \n     \n        Edit Actions\n     \n     \n         Arrange \n         Update \n         Remove \n     \n \n```","ref":"view-index.html#menus"},{"type":"extras","title":"Navigation - View Index","doc":"{: .col-2}","ref":"view-index.html#navigation"},{"type":"extras","title":"Pickers - View Index","doc":"{: .col-2}\n### ` `\nPresents a system color picker when tapped.\n\n\n\n```heex\n \n    Favorite Color\n \n```\n\n\n\n\n### ` `\nA control that lets the user pick a date.\n\n\n\n```heex\n \n     Pick a date \n \n```\n\n\n\n\n\n### ` `\nA control that allows the user to pick multiple dates (not datetimes).\n\n\n```heex\n \n     Pick as many dates as you like! \n \n```\n\n\n\n\n\n### ` `\nA control that picks one of multiple values.\n\n\n\n\n```heex\n \n     Transportation \n     \n         Car \n         Bus \n         Tram \n     \n \n```","ref":"view-index.html#pickers"},{"type":"extras","title":"Presentation Containers - View Index","doc":"{: .col-2}\n### ` `\nContainer with resizable splits between elements.\n\n\n\n\n```heex\n \n     \n     \n \n```\n\n\n\n### ` `\nA control users can tap to navigate to another live view.\n\n\n\n```heex\n \n     More Information \n \n```\n\n\n\n### ` `\nContainer that presents content on separate pages.\n\n\n\n```heex\n \n     \n     \n     \n \n```\n\n\n\n\n### ` `\nContainer with resizable splits between elements.\n\n\n\n\n```heex\n \n     \n     \n \n```","ref":"view-index.html#presentation-containers"},{"type":"extras","title":"Scroll Views - View Index","doc":"{: .col-2}\n### ` `\nA view that lets it contents be scrolled if larger than the available space.\n\n\n```heex\n \n     \n        <%= for color <- @colors %>\n             \n        <% end %>\n     \n \n```","ref":"view-index.html#scroll-views"},{"type":"extras","title":"Separators - View Index","doc":"{: .col-2}\n### ` `\nA view that expands to provide space between other views.\n\n\n```heex\n \n     First \n     \n     Second \n \n```","ref":"view-index.html#separators"},{"type":"extras","title":"Shapes - View Index","doc":"{: .col-2}\n### `Shape`\nA view that displays the a shape.","ref":"view-index.html#shapes"},{"type":"extras","title":"Sizing - View Index","doc":"{: .col-2}\n### ` `\nChooses the first child that fits in the available space.\n\n\n\n```heex\n \n     Long text content ...  \n     \n \n```","ref":"view-index.html#sizing"},{"type":"extras","title":"Stacks - View Index","doc":"{: .col-2}\n### ` `\nContainer that lays out its children in a horizontal line.\n\n\n```heex\n \n     Leading \n     \n     Trailing \n \n```\n\n\n\n### ` `\nContainer that lays out its children in a vertical line.\n\n\n```heex\n \n     Top \n     Bottom \n \n```\n\n\n\n### ` `\nA container that lays out elements on top of each other, back to front.\n\n\n```heex\n \n     Back \n     Front \n \n```","ref":"view-index.html#stacks"},{"type":"extras","title":"Text Input and Output - View Index","doc":"{: .col-2}\n### ` `\nA title and icon pair.\n\n\n\n```heex\n \n     John Doe \n     \n \n```\n\n\n```heex\n \n     John Doe \n \n```\n\n\n\n### ` `\nA form element for entering private text.\n\n\n\n```heex\n \n    Password\n \n```\n\n\n### ` `\nDisplays text.\n\n\n\n\n```heex\n Hello \n \n```\n\n\n```heex\n \n```\n\n\n```heex\n \n```\n\n\n```heex\n \n```\n\n\n```heex\n \n \n```\n\n\n```elixir\n\"large-bold\" do\n    font(.largeTitle)\n    bold()\nend\n```\n\n```heex\n \n    Hello, world!\n \n```\n\n\n```heex\n \n      \n     \n    Check out this thing I made:  mysite.com \n \n```\n\n\n\n### ` `\nA multi-line, long-form text editor.\n\n\n```heex\n \n```\n\n\n\n### ` `\nA form element for entering text.\n\n\n\n```heex\n \n    First Name\n \n```\n\n\n```heex\n \n     Last Name \n \n```\n\n\n```elixir\n\"search-field\" do\n  autocorrectDisabled(true)\n  textInputAutocapitalization(.words)\n  keyboardType(.webSearch)\n  submitLabel(.search)\nend\n```\n\n```heex\n \n    Enter Search Text\n \n```\n\n\n```heex\n \n     \n        Enter Amount\n     \n\n     \n        Enter Bank Address\n     \n \n```","ref":"view-index.html#text-input-and-output"},{"type":"extras","title":"Toolbars - View Index","doc":"{: .col-2}\n### ` `\nToolbar element for placing items.\n\n\n\n```heex\n \n     Delete \n \n```\n\n\n```elixir\ntoolbar(id: \"unique-toolbar-id\", content: :my_toolbar_content)\n```\n\n\n```heex\n \n    ...\n \n```\n\n\n```heex\n \n    ...\n \n```\n\n\n```heex\n \n    ...\n \n```\n\n\n### ` `\nToolbar element for placing multiple items.\n\n\n\n```heex\n \n     Delete \n     Destroy \n     Eradicate \n \n```\n\n\n### ` `\nToolbar element that opens a menu when the navigation title is tapped.\n\n\n\n```heex\n \n     Edit \n     Save \n     Open \n \n```","ref":"view-index.html#toolbars"},{"type":"extras","title":"Value Inputs - View Index","doc":"{: .col-2}\n### ` `\nA form element for selecting a value within a range.\n\n\n\n```heex\n \n```\n\n\n```heex\n \n```\n\n\n```heex\n \n```\n\n\n```heex\n \n     Percent Completed \n     0% \n     100% \n \n```\n\n\n### ` `\nA form element for incrementing/decrementing a value in a range.\n\n\n\n```heex\n \n    Attendees\n \n```\n\n\n```heex\n \n    Attendees\n \n```\n\n\n### ` `\nA form element that controls a boolean value.\n\n\n\n```heex\n \n    Lights On\n \n```","ref":"view-index.html#value-inputs"},{"type":"extras","title":"High-Level Overview","doc":"# High-Level Overview\n\n```mermaid\nflowchart TD\n    LV[ LiveView ]\n    LV --> LSC[ LiveSessionCoordinator ]\n    LSC --> |/route1| LVC1[ LiveViewCoordinator  1]\n    LSC --> |/route2| LVC2[ LiveViewCoordinator  2]\n    LSC --> |/route3| LVC3[ LiveViewCoordinator  3]\n```\n\n## [`LiveView`](https://github.com/liveview-native/liveview-client-swiftui/blob/main/Sources/LiveViewNative/LiveView.swift)\nThe `LiveView` struct is a SwiftUI View that connects to a Phoenix LiveView application. This View can be included anywhere in a SwiftUI View hierarchy.\n\n## [`LiveSessionCoordinator`](https://github.com/liveview-native/liveview-client-swiftui/blob/main/Sources/LiveViewNative/Coordinators/LiveSessionCoordinator.swift)\nEach `LiveView` is controlled by a `LiveSessionCoordinator`. The session coordinator is responsible for handling the WebSocket connection.\n\nThere is only one WebSocket open during lifetime of the `LiveView`.\n\n## [`LiveViewCoordinator`](https://github.com/liveview-native/liveview-client-swiftui/blob/main/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift)\nA `LiveView` SwiftUI View handles navigation internally. By using `push_event`, `push_patch`, or `redirect`, and Phoenix LiveView can change the top-most route in the navigation stack.\n\nEach entry in this navigation stack is controlled by a `LiveViewCoordinator`. This coordinator is responsible for a single Phoenix Channel, which communicates over the shared socket.\n\nThis separation exists so that multiple channels can be opened on the same socket. This allows for a sidebar/content/detail split where each split renders a different Phoenix LiveView.\n\n## [`NavStackEntryView`](https://github.com/liveview-native/liveview-client-swiftui/blob/main/Sources/LiveViewNative/NavStackEntryView.swift)\nThis View is controlled by the `LiveViewCoordinator` for a given navigation path.\n\nIt is the View that contains the content of the document as a SwiftUI View hierarchy.","ref":"architecture.html"},{"type":"extras","title":"Modifiers","doc":"# Modifiers\nThere are many `ViewModifiers` that can be applied to a `View`, such as `foregroundStyle`, `background`, `alert`, etc.\n\nThese modifiers are defined as functions on the `View` protocol in SwiftUI.\n\nA modifier function in SwiftUI is represented as a `struct` in LiveView Native.\n\n```swift\n// SwiftUI\nextension View {\n    func bold(_ isActive: Bool) -> some View\n}\n\n// LiveView Native\n@ParseableExpression\nstruct _boldModifier: ViewModifier {\n    static let name = \"bold\"\n\n    let isActive: Bool\n\n    init(_ isActive: Bool) {\n        self.isActive = isActive\n    }\n\n    func body(content: Content) -> some View {\n        content.bold(isActive)\n    }\n}\n```\n\nThe `@ParseableExpression` macro generates a parser based on the `init` definitions in the `struct`.","ref":"modifiers.html"},{"type":"extras","title":"Code Generation - Modifiers","doc":"Due to the large number of modifiers in SwiftUI, code generation is used to create modifier types from the functions in SwiftUI.\n\nSwift generates a `.swiftinterface` file for all frameworks in iOS. It contains all of the public symbols in the framework. For SwiftUI, you can find the `.swiftinterface` file inside of Xcode at this path:\n\n```\n/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS.sdk/System/Library/Frameworks/SwiftUI.framework/Modules/SwiftUI.swiftmodule/arm64-apple-ios.swiftinterface\n```\n\nThe code generator parses this file and converts any modifier functions into structs. You can run the generator with the following command.\n\n```\n# in the top level of this repo\nswift run ModifierGenerator \"/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS.sdk/System/Library/Frameworks/SwiftUI.framework/Modules/SwiftUI.swiftmodule/arm64-apple-ios.swiftinterface\" > Sources/LiveViewNative/_GeneratedModifiers.swift\n```\n\nThis will run the generator with SwiftUI's `.swiftinterface` file as input, and write the generated modifiers to the path `Sources/LiveViewNative/_GeneratedModifiers.swift`.\n\nThe source code for the generator can be found at `Sources/ModifierGenerator`. In `ModifierGenerator.swift`, you will find a `denylist`. To enable a new modifier in the output, remove it from the denylist.","ref":"modifiers.html#code-generation"},{"type":"extras","title":"Supporting Types - Modifiers","doc":"Modifiers use a variety of types as arguments, such as `Color`, `some ShapeStyle`, `Angle`, etc.\n\nThese supporting types can be found at `Sources/LiveViewNative/Stylesheets/ParseableTypes`.\n\nWhen the generator encounters a generic argument, it will prefix the protocol name with `Any`.\nFor example, `some ShapeStyle` becomes `AnyShapeStyle`.\n\nIf this type exists in SwiftUI, extend it to conform to `ParseableModifierValue`. Otherwise, create an eraser type that conforms to both protocols.","ref":"modifiers.html#supporting-types"},{"type":"extras","title":"Navigation","doc":"# Navigation\nThe [`navigationPath`](https://github.com/liveview-native/liveview-client-swiftui/blob/0e0fc6bbe5e95ef308e51551af0889acb09b87b3/Sources/LiveViewNative/Coordinators/LiveSessionCoordinator.swift#L43) is handled by the `LiveSessionCoordinator`. The `LiveViewCoordinator` receives navigation events from the Phoenix LiveView over the channel, and [sends the navigation request to the session coordinator](https://github.com/liveview-native/liveview-client-swiftui/blob/0e0fc6bbe5e95ef308e51551af0889acb09b87b3/Sources/LiveViewNative/Coordinators/LiveSessionCoordinator.swift#L353).","ref":"navigation.html"},{"type":"extras","title":"Kinds - Navigation","doc":"There are two styles of navigation, based on how they impact the `window.history` on the browser.\n\n### `push`\nThis style appends a history entry.\n\nIn the case of SwiftUI, this means there is a system page push animation, and a back button is available to navigate to the previous page.\n\n### `replace`\nThis style replaces the current history entry.\n\nIn the case of SwiftUI, this means the top-most entry in the `navigationPath` is replaced with the new route. No back button is available to return to the previous page.","ref":"navigation.html#kinds"},{"type":"extras","title":"Events - Navigation","doc":"There are three main navigation events in Phoenix LiveView.\n\n> When reconnecting on a new channel, the `redirect` key is used instead of the `url` key in the [connect params](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L238).\n\n### `redirect`\nThis method sends a [`redirect` event](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L274-L281).\n\n> Can also be received [in response to an event](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L131).\n\n```json\n\"redirect\": {\n    \"to\": \" \"\n}\n```\n\nThis performs a `push` style navigation.\n\nThe channel is closed and a new channel connects on the same socket.\n\n### `push_navigate`\nThis method sends a [`live_redirect` event](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L258-L265).\n\n> Can also be received [in response to an event](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L128C25-L128C25).\n\n```json\n\"live_redirect\": {\n    \"kind\": \" \",\n    \"to\": \" \"\n}\n```\n\nThe channel is closed and a new channel connects on the same socket.\n\n### `push_patch`\nThis method sends a [`live_patch` event](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L266-L273).\n\n```json\n{\n    \"kind\": \" \",\n    \"to\": \" \"\n}\n```\n\nThe channel persists, unlike other forms of navigation. Only the query parameters of the URL are changed.","ref":"navigation.html#events"},{"type":"extras","title":"Updates","doc":"# Updates\nWhenever the template changes, a [`diff` event](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L250-L257) is sent to the client. `liveview-native-core` handles most of this process.","ref":"updates.html"},{"type":"extras","title":"Update Process - Updates","doc":"1. When the page loads, Phoenix sends a JSON representation of the [`Phoenix.LiveView.Rendered` struct](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.Engine.html#module-phoenix-liveview-rendered)\n2. [The client parses this data](https://github.com/liveview-native/liveview-client-swiftui/blob/0e0fc6bbe5e95ef308e51551af0889acb09b87b3/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L380), and forms a complete HTML document. It passes this HTML string to core to be parsed.\n3. Core [sends back a `Document`](https://github.com/liveview-native/liveview-client-swiftui/blob/0e0fc6bbe5e95ef308e51551af0889acb09b87b3/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L381) with parsed nodes and elements, which the client renders to native elements\n4. The client sends an event in response to some user interaction\n5. The LiveView computes the changes, and sends a fragment diff to the client.\n6. The client [merges this fragment diff](https://github.com/liveview-native/liveview-client-swiftui/blob/0e0fc6bbe5e95ef308e51551af0889acb09b87b3/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L192) with the previous `Rendered` struct, and sends the complete HTML to core to parse.\n7. Core returns a parsed document.\n8. The client asks core to [merge the new document](https://github.com/liveview-native/liveview-client-swiftui/blob/0e0fc6bbe5e95ef308e51551af0889acb09b87b3/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L193) into the old document so they match.\n9. Core [sends the ID of any changed nodes](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L390-L406) to the client to update.\n\n```mermaid\nsequenceDiagram\n    LiveView ->> Client: 1. Rendered JSON\n    Client ->> Core: 2. Parse HTML\n    Core ->> Client: 3. Document\n    Client ->> LiveView: 4. Event \"increment\"\n    LiveView ->> Client: 5. Rendered Diff\n    Client ->> Core: 6. Parse New HTML\n    Client ->> Core: 7. New Document\n    Client ->> Core: 8. Merge Documents\n    Core ->> Client: 9. Changed NodeRefs\n```","ref":"updates.html#update-process"},{"type":"extras","title":"Update Isolation - Updates","doc":"To keep updates fast, individual Views are updated based on the elements that change between a diff.\n\nThe `LiveViewCoordinator` stores [a dictionary that maps a `NodeRef` to a Combine publisher](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L41).\n\nWhenever [core sends an update event](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Coordinators/LiveViewCoordinator.swift#L390-L406) for this `NodeRef`, a signal is sent through the corresponding publisher to all of its subscribers.\n\n### `@ObservedElement`\nThe `ObservedElement` property wrapper watches for changes to the node, and triggers a View update when change events are received.\n\nThis is done through the `Observer` class. [It subscribes to the Combine publisher for the matching `NodeRef`](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/Property%20Wrappers/ObservedElement.swift#L120-L123).\n\n[One `Observer` instance is created](https://github.com/liveview-native/liveview-client-swiftui/blob/9895c3b16d84a2683dcb1f127994be6c1bdf4919/Sources/LiveViewNative/ViewTree.swift#L52) for each View to avoid redundant subscriptions in the case of multiple `ObservedElement` wrappers (common when using `@Attribute`).\n\n```mermaid\nflowchart TD\n    subgraph LiveViewCoordinator\n        LVC[LiveViewCoordinator]\n        LVC --> |node #1 changed| VP1[Node #1 Publisher]\n        LVC --> VP2[Node #2 Publisher]\n        LVC --> VP3[Node #... Publisher]\n    end\n\n    VP1 -.-> |node #1 changed| O\n\n    subgraph Environment\n        O[Observer]\n    end\n\n    subgraph Node #1 SwiftUI View\n        OE1[\"@ObservedElement\"]\n        A1[\"@Attribute\"]\n        A2[\"@Attribute\"]\n        A1 --> OE2[\"@ObservedElement\"]\n        A2 --> OE3[\"@ObservedElement\"]\n    end\n\n    O -.-> OE1\n    O -.-> OE2\n    O -.-> OE3\n```","ref":"updates.html#update-isolation"},{"type":"extras","title":"ScaledMetric","doc":"# ScaledMetric\n<!-- tooltip support -->\n \n\n \n\n&lt;ScaledMetric&gt;\n\n \n\n \n   Tracks changed to the dynamic type size in the current context. \n \n\n \n<!-- end tooltip support -->","ref":"scaledmetric.html"},{"type":"extras","title":"Overview - ScaledMetric","doc":"Use this element to scale a value with the accessibility dynamic type size.\n\n```heex\n \n   \n \n```\n\n```elixir\ndefmodule MyAppWeb.AccessibilityLive do\n  def handle_event(\"scaled-value-changed\", scaled_value, socket) do\n    {:noreply, assign(socket, scaled_value: scaled_value)}\n  end\nend\n```\nThe initial [`value`](#value/1) of `100` will be used when dynamic type is disabled. If the dynamic type size is changed, the event referenced by `phx-change` will be updated with a scaled version of [`value`](#value/1).\nOptionally provide a [`Font.TextStyle`](swiftui/font/textstyle.html#Font.TextStyle/1) to scale relative to with the [`relativeTo`](#relativeTo/1) attribute.","ref":"scaledmetric.html#overview"},{"type":"extras","title":"Attributes - ScaledMetric","doc":"* [`value`](#value/1)\n* [`relativeTo`](#relativeTo/1)","ref":"scaledmetric.html#attributes"},{"type":"extras","title":"Bindings - ScaledMetric","doc":"* `scaledValue`","ref":"scaledmetric.html#bindings"},{"type":"extras","title":"SwiftUI Documentation - ScaledMetric","doc":"See [`SwiftUI.ScaledMetric`](https://developer.apple.com/documentation/swiftui/ScaledMetric) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     phx-change \n   \n   \n\n The event to update with the scaled   value  . \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     relativeTo \n   \n   \n\n The   Font.TextStyle   to scale with. Defaults to  body . \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     value \n   \n   \n\n The initial value to scale. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"scaledmetric.html#swiftui-documentation"},{"type":"extras","title":"Button","doc":"# Button\n<!-- tooltip support -->\n \n\n \n\n&lt;Button&gt;\n\n \n\n \n    &lt;Button&gt; , sends events when tapped. \n \n\n \n<!-- end tooltip support -->","ref":"button.html"},{"type":"extras","title":"Overview - Button","doc":"Use the `phx-click` attribute to specify which event to fire on tap.\n\n```heex\n Click Me! \n```\n\n```elixir\ndef handle_event(\"my_event\", %{ \"extra\" => extra }, socket) do\n    {:noreply, assign(socket, value: extra)}\nend\n```","ref":"button.html#overview"},{"type":"extras","title":"Attributes - Button","doc":"* [`role`](#role/1)","ref":"button.html#attributes"},{"type":"extras","title":"Events - Button","doc":"* [`phx-click`](#phx-click/1)","ref":"button.html#events"},{"type":"extras","title":"SwiftUI Documentation - Button","doc":"See [`SwiftUI.Button`](https://developer.apple.com/documentation/swiftui/Button) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     phx-click \n   \n   \n\n Event triggered when tapped. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     role \n   \n   \n\n The semantic role of the button. \n\n Discussion  Possible values:    destructive    cancel   \n\n   \n \n\n\n<!-- end attribute list -->","ref":"button.html#swiftui-documentation"},{"type":"extras","title":"PasteButton","doc":"# PasteButton\n<!-- tooltip support -->\n \n\n \n\n&lt;PasteButton&gt;\n\n \n\n \n   Sends an event with the clipboard’s contents when tapped. \n \n\n \n<!-- end tooltip support -->","ref":"pastebutton.html"},{"type":"extras","title":"Overview - PasteButton","doc":"Use the `phx-click` attribute to specify which event to fire on tap.\n\n```heex\n \n```\n\n```elixir\ndef handle_event(\"my_event\", %{ \"value\" => value }, socket) do\n  {:noreply, assign(socket, :pasted_value, hd(value))}\nend\n```","ref":"pastebutton.html#overview"},{"type":"extras","title":"Events - PasteButton","doc":"* [`phx-click`](#phx-click/1)","ref":"pastebutton.html#events"},{"type":"extras","title":"SwiftUI Documentation - PasteButton","doc":"See [`SwiftUI.PasteButton`](https://developer.apple.com/documentation/swiftui/PasteButton) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     phx-click \n   \n   \n\n Event sent when tapped. \n\n Discussion  Sends a payload with the following format:   {\n    &quot;value&quot;: [\n        &quot;clipboard string 1&quot;,\n        &quot;clipboard string 2&quot;,\n        ...\n    ]\n}  \n\n   \n \n\n\n<!-- end attribute list -->","ref":"pastebutton.html#swiftui-documentation"},{"type":"extras","title":"List","doc":"# List\n<!-- tooltip support -->\n \n\n \n\n&lt;List&gt;\n\n \n\n \n   Presents rows of elements. \n \n\n \n<!-- end tooltip support -->","ref":"list.html"},{"type":"extras","title":"Overview - List","doc":"Each element inside the list is given its own row.\n\n```heex\n \n    <%= for sport <- @sports do %>\n         <%= sport.name %> \n    <% end %>\n \n```","ref":"list.html#overview"},{"type":"extras","title":"Edit Mode - List","doc":"Use an [` `](editbutton.html#EditButton/1) to enter edit mode. This will allow rows to be moved, selected, and deleted.\n\n```heex\n \n  ...  \n```","ref":"list.html#edit-mode"},{"type":"extras","title":"Selecting Rows - List","doc":"Use the [`selection`](#selection/1) attribute to set the selected row(s).\n\n```heex\n \n    ...\n \n```","ref":"list.html#selecting-rows"},{"type":"extras","title":"Deleting and Moving Rows - List","doc":"Set an event name for the [`phx-delete`](#phx-delete/1) attribute to enable the system delete action.\nAn event is sent with the `index` of the item to delete.\n\n```heex\n \n    ...\n \n```\n\n```elixir\ndefmodule MyAppWeb.SportsLive do\n    def handle_event(\"on_delete\", %{ \"index\" => index }, socket) do\n        {:noreply, assign(socket, :items, List.delete_at(socket.assigns.items, index))}\n    end\nend\n```\nUse the [`phx-move`](#phx-move/1) event to enable the system move actions.\nAn event is sent with the `index` of the item to move and its `destination` index.\n\n```heex\n \n    ...\n \n```\n\n```elixir\ndefmodule MyAppWeb.SportsLive do\n    def handle_event(\"on_move\", %{ \"index\" => index, \"destination\" => destination }, socket) do\n        {element, list} = List.pop_at(socket.assigns.sports, index)\n        moved = List.insert_at(list, (if destination > index, do: destination - 1, else: destination), element)\n        {:noreply, assign(socket, :sports, moved)}\n    end\nend\n```","ref":"list.html#deleting-and-moving-rows"},{"type":"extras","title":"Attributes - List","doc":"* [`selection`](#selection/1)","ref":"list.html#attributes"},{"type":"extras","title":"Events - List","doc":"* [`phx-delete`](#phx-delete/1)\n* [`phx-move`](#phx-move/1)","ref":"list.html#events"},{"type":"extras","title":"SwiftUI Documentation - List","doc":"See [`SwiftUI.List`](https://developer.apple.com/documentation/swiftui/List) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     phx-delete \n   \n   \n\n Event sent when a row is deleted. \n\n Discussion  An event is sent with the  index  of the item to delete.   &lt;List phx-delete=&quot;on_delete&quot;&gt;\n    ...\n&lt;/List&gt;    defmodule MyAppWeb.SportsLive do\n    def handle_event(&quot;on_delete&quot;, %{ &quot;index&quot; =&gt; index }, socket) do\n        {:noreply, assign(socket, :items, List.delete_at(socket.assigns.items, index))}\n    end\nend  \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     phx-move \n   \n   \n\n Event sent when a row is moved. \n\n Discussion  An event is sent with the  index  of the item to move and its  destination  index.   &lt;List phx-move=&quot;on_move&quot;&gt;\n    ...\n&lt;/List&gt;    defmodule MyAppWeb.SportsLive do\n    def handle_event(&quot;on_move&quot;, %{ &quot;index&quot; =&gt; index, &quot;destination&quot; =&gt; destination }, socket) do\n        {element, list} = List.pop_at(socket.assigns.sports, index)\n        moved = List.insert_at(list, (if destination &gt; index, do: destination - 1, else: destination), element)\n        {:noreply, assign(socket, :sports, moved)}\n    end\nend  \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     selection \n   \n   \n\n Synchronizes the selected rows with the server. \n\n Discussion  To allow an arbitrary number of rows to be selected, use the  List  type for the value. Use an empty list as the default value to start with no selection.\nTo only allow a single selection, use the  String  type for the value. Use  nil  as the default value to start with no selection. \n\n   \n \n\n\n<!-- end attribute list -->","ref":"list.html#swiftui-documentation"},{"type":"extras","title":"Section","doc":"# Section\n<!-- tooltip support -->\n \n\n \n\n&lt;Section&gt;\n\n \n\n \n   Groups elements in a container. \n \n\n \n<!-- end tooltip support -->","ref":"section.html"},{"type":"extras","title":"Overview - Section","doc":"Use a section to group together elements in [` `](list.html#List/1), [` `](picker.html#Picker/1), and other container elements.\n\n```heex\n \n     Item #1 \n    ...\n \n \n     Item #1 \n    ...\n \n```\nAdd a `header` and `footer` to customize sections.\n\n```heex\n \n     Group #1 \n     Item #1 \n     The first group ends here \n \n \n     Group #2 \n     Item #1 \n     The second group ends here \n \n```\nOn macOS, `ListStyle/sidebar` can have collapsible sections. Use the [`collapsible`](#collapsible/1) attribute to make a section collapsible.\n\n```heex\n \n    ...\n \n```","ref":"section.html#overview"},{"type":"extras","title":"Attributes - Section","doc":"* [`collapsible`](#collapsible/1)","ref":"section.html#attributes"},{"type":"extras","title":"Children - Section","doc":"* `content` - The main body of the section.\n* `header` - Describes the content of the section.\n* `footer` - Elements displayed at the end of the section.","ref":"section.html#children"},{"type":"extras","title":"SwiftUI Documentation - Section","doc":"See [`SwiftUI.Section`](https://developer.apple.com/documentation/swiftui/Section) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     collapsible \n   \n   \n\n Enables this section to be collapsed in sidebar lists on macOS. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"section.html#swiftui-documentation"},{"type":"extras","title":"Table","doc":"# Table\n<!-- tooltip support -->\n \n\n \n\n&lt;Table&gt;\n\n \n\n \n   A container organized by rows and columns. \n \n\n \n<!-- end tooltip support -->","ref":"table.html"},{"type":"extras","title":"Overview - Table","doc":"Use ` ` elements in the `columns` child, and ` ` elements in the `rows` child to build the table’s content.\nEach ` ` should have the same number of children as columns in the table.\n\n```heex\n \n     \n         Name \n         Description \n         Length \n     \n     \n         \n             Basketball \n             Players attempt to throw a ball into an elevated basket. \n             48 min \n         \n         \n             Soccer \n             Players attempt to kick a ball into a goal. \n             90 min \n         \n         \n             Football \n             Players attempt to throw a ball into an end zone. \n             60 min \n         \n     \n \n```","ref":"table.html#overview"},{"type":"extras","title":"Sorting Tables - Table","doc":"Use the [`sortOrder`](#sortOrder/1) attribute to handle changes in the sorting options.\n\n```heex\n \n    ...\n     \n        <%= for sport <- Enum.sort_by(\n            @sports,\n            fn sport -> sport[hd(@sports_sort_order)[\"id\"]] end,\n            (if hd(@sports_sort_order)[\"order\"], do: &</2, else: &>/2)\n        ) do %>\n             \n                 <%= sport[\"name\"] %> \n                 <%= sport[\"description\"] %> \n                 <%= sport[\"length\"] %> \n             \n        <% end %>\n     \n \n```","ref":"table.html#sorting-tables"},{"type":"extras","title":"Selecting Rows - Table","doc":"Use the [`selection`](#selection/1) attribute to synchronize the selected row(s) with the LiveView.\n\n```heex\n \n    ...\n \n```","ref":"table.html#selecting-rows"},{"type":"extras","title":"Bindings - Table","doc":"* [`selection`](#selection/1)\n* [`sortOrder`](#sortOrder/1)","ref":"table.html#bindings"},{"type":"extras","title":"Children - Table","doc":"* `columns` - Up to 10 ` ` elements that describe the possible columns.\n* `rows` -  An arbitrary number of ` ` elements, each with a unique `id` attribute.","ref":"table.html#children"},{"type":"extras","title":"ColorView","doc":"# ColorView\n<!-- tooltip support -->\n \n\n \n\n&lt;ColorView&gt;\n\n \n\n \n   A rectangle with a particular fill color. \n \n\n \n<!-- end tooltip support -->","ref":"colorview.html"},{"type":"extras","title":"Overview - ColorView","doc":"Color’s appearance is equivalent to a [`Rectangle`](rectangle.html#Rectangle/1) with a `fill-color`.\nCreate a color with [`red`](#red/1), [`green`](#green/1), [`blue`](#blue/1), and [`opacity`](#opacity/1) components.\n\n```heex\n \n```\nA color can also be created by its [`name`](#name/1). Named colors can be declared in the app’s asset catalog.\n\n```heex\n \n```\nThe [`name`](#name/1) attribute can also be used to create a system color or a CSS hex color.\n\n```heex\n \n \n```\nSee [`init(fromNamedOrCSSHex:)`](swiftui/color/init(fromnamedorcsshex:).html#init(fromNamedOrCSSHex:)/1) for more details.","ref":"colorview.html#overview"},{"type":"extras","title":"Attributes - ColorView","doc":"* [`red`](#red/1)\n* [`green`](#green/1)\n* [`blue`](#blue/1)\n* [`name`](#name/1)\n* [`opacity`](#opacity/1)\n* [`colorSpace`](#colorSpace/1)","ref":"colorview.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - ColorView","doc":"See [`SwiftUI.ColorView`](https://developer.apple.com/documentation/swiftui/ColorView) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     blue \n   \n   \n\n The blue channel of the color, in the range  0  to  1 . \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     colorSpace \n   \n   \n\n The color space this color is in. \n\n Discussion  Possible values:    sRGB    sRGBLinear    displayP3   \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     green \n   \n   \n\n The green channel of the color, in the range  0  to  1 . \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     name \n   \n   \n\n A named color in the project’s asset catalog, system color, or CSS hex color. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     opacity \n   \n   \n\n The alpha channel of the color, in the range  0  to  1 . \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     red \n   \n   \n\n The red channel of the color, in the range  0  to  1 . \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"colorview.html#swiftui-documentation"},{"type":"extras","title":"NamespaceContext","doc":"# NamespaceContext\n<!-- tooltip support -->\n \n\n \n\n&lt;NamespaceContext&gt;\n\n \n\n \n   Creates a namespace for child elements to use. \n \n\n \n<!-- end tooltip support -->","ref":"namespacecontext.html"},{"type":"extras","title":"Overview - NamespaceContext","doc":"Used with `MatchedGeometryEffectModifier` to create a namespace. The [`id`](#id/1) specified can be passed into `MatchedGeometryEffectModifier/namespace` on a child of this element.","ref":"namespacecontext.html#overview"},{"type":"extras","title":"Attributes - NamespaceContext","doc":"* [`id`](#id/1)","ref":"namespacecontext.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - NamespaceContext","doc":"See [`SwiftUI.NamespaceContext`](https://developer.apple.com/documentation/swiftui/NamespaceContext) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     id \n   \n   \n\n The unique identifier for this namespace. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"namespacecontext.html#swiftui-documentation"},{"type":"extras","title":"Form","doc":"# Form\n<!-- tooltip support -->\n \n\n \n\n&lt;Form&gt;\n\n \n\n \n   A container for grouping labeled form controls in a consistent style. \n \n\n \n<!-- end tooltip support -->","ref":"form.html"},{"type":"extras","title":"Overview - Form","doc":"","ref":"form.html#overview"},{"type":"extras","title":"SwiftUI Documentation - Form","doc":"See [`SwiftUI.Form`](https://developer.apple.com/documentation/swiftui/Form) for more details on this View.","ref":"form.html#swiftui-documentation"},{"type":"extras","title":"LabeledContent","doc":"# LabeledContent\n<!-- tooltip support -->\n \n\n \n\n&lt;LabeledContent&gt;\n\n \n\n \n   Presents an element with an associated label. \n \n\n \n<!-- end tooltip support -->","ref":"labeledcontent.html"},{"type":"extras","title":"Overview - LabeledContent","doc":"Use the `content` and `label` children to create this element.\n\n```heex\n \n     Price \n     $100.00 \n \n```","ref":"labeledcontent.html#overview"},{"type":"extras","title":"Formatting Values - LabeledContent","doc":"A value can be automatically formatted when the [`format`](#format/1) attribute is used. In this case, all child elements are used as the label, and the `value` attribute stores the content.\nFor more details on formatting options, see [` `](text.html#Text/1).\n\n```heex\n \n    Price\n \n```","ref":"labeledcontent.html#formatting-values"},{"type":"extras","title":"Attributes - LabeledContent","doc":"* [`format`](#format/1)","ref":"labeledcontent.html#attributes"},{"type":"extras","title":"Children - LabeledContent","doc":"* `content` - The element to label.\n* `label` - A description of the content.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     format \n   \n   \n\n Automatically formats the value of the  value  attribute. \n\n Discussion  For more details on formatting options, see   &lt;Text&gt;  . \n\n   \n \n\n\n<!-- end attribute list -->","ref":"labeledcontent.html#children"},{"type":"extras","title":"Grid","doc":"# Grid\n<!-- tooltip support -->\n \n\n \n\n&lt;Grid&gt;\n\n \n\n \n   Align elements along two dimensions. \n \n\n \n<!-- end tooltip support -->","ref":"grid.html"},{"type":"extras","title":"Overview - Grid","doc":"Use with [` `](gridrow.html#GridRow/1) to create a structured layout of elements.\n\n```heex\n \n     \n         Title \n         Description \n     \n     \n         Item #1 \n         The first of many items. \n     \n \n```","ref":"grid.html#overview"},{"type":"extras","title":"Attributes - Grid","doc":"* [`alignment`](#alignment/1)\n* [`horizontalSpacing`](#horizontalSpacing/1)\n* [`verticalSpacing`](#verticalSpacing/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The positioning of elements within the grid. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     horizontalSpacing \n   \n   \n\n The spacing between elements in a   &lt;GridRow&gt;  . \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     verticalSpacing \n   \n   \n\n The spacing between   &lt;GridRow&gt;   elements. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"grid.html#attributes"},{"type":"extras","title":"GridRow","doc":"# GridRow\n<!-- tooltip support -->\n \n\n \n\n&lt;GridRow&gt;\n\n \n\n \n   A row of items in a grid. \n \n\n \n<!-- end tooltip support -->","ref":"gridrow.html"},{"type":"extras","title":"Overview - GridRow","doc":"Use with [` `](grid.html#Grid/1) to define the rows of the grid.\n\n```heex\n \n     \n         Title \n         Description \n     \n     \n         Item #1 \n         The first of many items. \n     \n \n```","ref":"gridrow.html#overview"},{"type":"extras","title":"Attributes - GridRow","doc":"* [`alignment`](#alignment/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The positioning of elements within the row. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"gridrow.html#attributes"},{"type":"extras","title":"ControlGroup","doc":"# ControlGroup\n<!-- tooltip support -->\n \n\n \n\n&lt;ControlGroup&gt;\n\n \n\n \n   Visual grouping of control elements. \n \n\n \n<!-- end tooltip support -->","ref":"controlgroup.html"},{"type":"extras","title":"Overview - ControlGroup","doc":"Provide the `content` and `label` children to create a control group.\n\n```heex\n \n     Edit Actions \n     \n         Arrange \n         Update \n         Remove \n     \n \n```","ref":"controlgroup.html#overview"},{"type":"extras","title":"Attributes - ControlGroup","doc":"* `style`","ref":"controlgroup.html#attributes"},{"type":"extras","title":"Children - ControlGroup","doc":"* `label` - Describes the content of the control group.\n* `content` - Controls to be grouped together.","ref":"controlgroup.html#children"},{"type":"extras","title":"DisclosureGroup","doc":"# DisclosureGroup\n<!-- tooltip support -->\n \n\n \n\n&lt;DisclosureGroup&gt;\n\n \n\n \n   An expandable section of content. \n \n\n \n<!-- end tooltip support -->","ref":"disclosuregroup.html"},{"type":"extras","title":"Overview - DisclosureGroup","doc":"Use the `content` and `label` children to create a disclosure group.\n\n```heex\n \n     Edit Actions \n     \n         Arrange \n         Update \n         Remove \n     \n \n```\nTo synchronize the expansion state with the server, use the [`isExpanded`](#isExpanded/1) attribute.\n\n```heex\n \n    ...\n \n```","ref":"disclosuregroup.html#overview"},{"type":"extras","title":"Bindings - DisclosureGroup","doc":"* [`isExpanded`](#isExpanded/1)","ref":"disclosuregroup.html#bindings"},{"type":"extras","title":"Children - DisclosureGroup","doc":"* `label` - Describes the content of the disclosure group.\n* `content` - The elements below the fold.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     isExpanded \n   \n   \n\n Synchronizes the expansion state with the server. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"disclosuregroup.html#children"},{"type":"extras","title":"Group","doc":"# Group\n<!-- tooltip support -->\n \n\n \n\n&lt;Group&gt;\n\n \n\n \n   A collection of elements. \n \n\n \n<!-- end tooltip support -->","ref":"group.html"},{"type":"extras","title":"Overview - Group","doc":"You can use groups to apply modifiers to multiple elements without code duplication.\n\n```heex\n \n     Orange Button \n     Orange Toggle \n     Orange Slider \n \n```\nGroups can also be used to surpass the 10 child limit.\n\n```heex\n \n     \n         1 \n         2 \n         3 \n         4 \n         5 \n         6 \n         7 \n         8 \n         9 \n         10 \n     \n     11 \n \n```","ref":"group.html#overview"},{"type":"extras","title":"SwiftUI Documentation - Group","doc":"See [`SwiftUI.Group`](https://developer.apple.com/documentation/swiftui/Group) for more details on this View.","ref":"group.html#swiftui-documentation"},{"type":"extras","title":"GroupBox","doc":"# GroupBox\n<!-- tooltip support -->\n \n\n \n\n&lt;GroupBox&gt;\n\n \n\n \n   Visual grouping of elements. \n \n\n \n<!-- end tooltip support -->","ref":"groupbox.html"},{"type":"extras","title":"Overview - GroupBox","doc":"Use the `label` and `content` children to create a group box.\n\n```heex\n \n     Edit Actions \n     \n         Arrange \n         Update \n         Remove \n     \n \n```\nAlternatively, use the [`title`](#title/1) attribute instead of the `label` child.\n\n```heex\n \n     Arrange \n     Update \n     Remove \n \n```","ref":"groupbox.html#overview"},{"type":"extras","title":"Attributes - GroupBox","doc":"* [`title`](#title/1)","ref":"groupbox.html#attributes"},{"type":"extras","title":"Children - GroupBox","doc":"* `label` - Describes the content of the group box.\n* `content` - The elements to group together.","ref":"groupbox.html#children"},{"type":"extras","title":"SwiftUI Documentation - GroupBox","doc":"See [`SwiftUI.GroupBox`](https://developer.apple.com/documentation/swiftui/GroupBox) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     title \n   \n   \n\n The title to use. \n\n Discussion  Takes precedence over a  label  child. \n\n   \n \n\n\n<!-- end attribute list -->","ref":"groupbox.html#swiftui-documentation"},{"type":"extras","title":"AsyncImage","doc":"# AsyncImage\n<!-- tooltip support -->\n \n\n \n\n&lt;AsyncImage&gt;\n\n \n\n \n   Displays an image asynchronously loaded from a URL. \n \n\n \n<!-- end tooltip support -->","ref":"asyncimage.html"},{"type":"extras","title":"Overview - AsyncImage","doc":"```heex\n \n```\nWhile the image is loading, a circular progress view is shown. If the image fails to load, text containing the error message is shown.\nAttributes:\n* [`url`](#url/1)\n* [`scale`](#scale/1)","ref":"asyncimage.html#overview"},{"type":"extras","title":"SwiftUI Documentation - AsyncImage","doc":"See [`SwiftUI.AsyncImage`](https://developer.apple.com/documentation/swiftui/AsyncImage) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     scale \n   \n   \n\n The display scale of the image (defaults to 1). \n\n Discussion  This corresponds to the  @2x ,  @3x  suffixes you would use for images shipped with the app. A scale of 1 indicates that 1 pixel in the image corresponds to 1 point, a scale of 2 indicates that there are 2 image pixels per point, etc. \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     url \n   \n   \n\n The URL from which to load the image (relative to the current Live View’s URL). \n\n Discussion  If no URL is provided, the view will remain in the loading state. \n\n   \n \n\n\n<!-- end attribute list -->","ref":"asyncimage.html#swiftui-documentation"},{"type":"extras","title":"ImageView","doc":"# ImageView\n<!-- tooltip support -->\n \n\n \n\n&lt;ImageView&gt;\n\n \n\n \n   Displays an image. \n \n\n \n<!-- end tooltip support -->","ref":"imageview.html"},{"type":"extras","title":"Overview - ImageView","doc":"There are two possible sources for images: system-provided images (SF Symbols) or the app’s asset catalog.","ref":"imageview.html#overview"},{"type":"extras","title":"SF Symbols - ImageView","doc":"The platform provides a wide variety of symbol images which are specified with the [`systemName`](#systemName/1) attribute. See [`Apple’s documentation`](https://developer.apple.com/sf-symbols/) for more information.","ref":"imageview.html#sf-symbols"},{"type":"extras","title":"Asset Catalog - ImageView","doc":"Specify the `name` attribute to use a named image from the app’s asset catalog.\n\n```heex\n \n```","ref":"imageview.html#asset-catalog"},{"type":"extras","title":"Variable Value - ImageView","doc":"Some symbols and asset images support a value input. Use the [`variableValue`](#variableValue/1) attribute to set this value.\n\n```heex\n \n \n \n```","ref":"imageview.html#variable-value"},{"type":"extras","title":"Image Labels - ImageView","doc":"Text content within the image will be used as the accessibility label.\n\n```heex\n \n  Mountain landscape with a lake in the foreground\n \n```","ref":"imageview.html#image-labels"},{"type":"extras","title":"Modifying Images - ImageView","doc":"Use image modifiers to customize the appearance of an image.\n\n```elixir\n\"heart\" do\n    resizable()\n    symbolRenderingMode(.multicolor)\nend\n```\n\n```heex\n \n```","ref":"imageview.html#modifying-images"},{"type":"extras","title":"Attributes - ImageView","doc":"* [`systemName`](#systemName/1)\n* [`name`](#name/1)\n* [`variableValue`](#variableValue/1)","ref":"imageview.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - ImageView","doc":"See [`SwiftUI.ImageView`](https://developer.apple.com/documentation/swiftui/ImageView) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     name \n   \n   \n\n The name of an image in the app’s asset catalog. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     systemName \n   \n   \n\n The name of the system image (SF Symbol) to display. \n\n Discussion  See   Apple’s documentation   for more information. \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     variableValue \n   \n   \n\n The value represented by this image, in the range  0.0  to  1.0 . \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"imageview.html#swiftui-documentation"},{"type":"extras","title":"Gauge","doc":"# Gauge\n<!-- tooltip support -->\n \n\n \n\n&lt;Gauge&gt;\n\n \n\n \n   Displays a value within a range. \n \n\n \n<!-- end tooltip support -->","ref":"gauge.html"},{"type":"extras","title":"Overview - Gauge","doc":"Several child elements can be used to customize how [` `](gauge.html#Gauge/1) is displayed.\n\n```heex\n \n     50% \n     0.5 \n     0 \n     1 \n \n```","ref":"gauge.html#overview"},{"type":"extras","title":"Attributes - Gauge","doc":"* [`value`](#value/1)\n* [`lowerBound`](#lowerBound/1)\n* [`upperBound`](#upperBound/1)","ref":"gauge.html#attributes"},{"type":"extras","title":"Children - Gauge","doc":"* `currentValueLabel` - Describes the current value.\n* `minimumValueLabel` - Describes the lowest possible value.\n* `maximumValueLabel` - Describes the highest possible value.","ref":"gauge.html#children"},{"type":"extras","title":"SwiftUI Documentation - Gauge","doc":"See [`SwiftUI.Gauge`](https://developer.apple.com/documentation/swiftui/Gauge) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     lowerBound \n   \n   \n\n The lowest possible value of the gauge. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     upperBound \n   \n   \n\n The highest possible value of the gauge. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     value \n   \n   \n\n The current value of the gauge. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"gauge.html#swiftui-documentation"},{"type":"extras","title":"ProgressView","doc":"# ProgressView\n<!-- tooltip support -->\n \n\n \n\n&lt;ProgressView&gt;\n\n \n\n \n   Displays progress toward a target value. \n \n\n \n<!-- end tooltip support -->","ref":"progressview.html"},{"type":"extras","title":"Overview - ProgressView","doc":"This element can represent a indeterminate spinner in its most basic form.\n\n```heex\n \n```\nUse [`value`](#value/1) and [`total`](#total/1) to display a specific value.\n\n```heex\n \n \n     Completed Percentage \n     25% \n \n```\nCreate a timer with [`timerInterval:start`](#timerInterval:start/1) and [`timerInterval:end`](#timerInterval:end/1)\n\n```heex\n  DateTime.add(5, :minute)}\n/>\n```","ref":"progressview.html#overview"},{"type":"extras","title":"Attributes - ProgressView","doc":"* [`value`](#value/1)\n* [`total`](#total/1)\n* [`timerInterval:start`](#timerInterval:start/1)\n* [`timerInterval:end`](#timerInterval:end/1)\n* [`countsDown`](#countsDown/1)","ref":"progressview.html#attributes"},{"type":"extras","title":"Children - ProgressView","doc":"* `label` - Describes the purpose of the element.\n* `currentValueLabel` - Describes the current value.","ref":"progressview.html#children"},{"type":"extras","title":"LazyHGrid","doc":"# LazyHGrid\n<!-- tooltip support -->\n \n\n \n\n&lt;LazyHGrid&gt;\n\n \n\n \n   Grid that grows horizontally. \n \n\n \n<!-- end tooltip support -->","ref":"lazyhgrid.html"},{"type":"extras","title":"Overview - LazyHGrid","doc":"Use the [`rows`](#rows/1) attribute to configure the presentation of the grid.\n\n```heex\n \n    <%= for i <- 1..50 do %>\n          Integer.to_string}><%= i %> \n    <% end %>\n \n```\nThere are 3 types of grid item:\n* `fixed(size, spacing, alignment)`: creates a single row that takes up the specified amount of space.\n* `flexible(minimum, maximum, spacing, alignment)`: creates a single row that fills the available space.\n* `adaptive(minimum, maximum, spacing, alignment)`: fills the available space with as many rows as will fit.","ref":"lazyhgrid.html#overview"},{"type":"extras","title":"Attributes - LazyHGrid","doc":"* [`rows`](#rows/1)\n* [`alignment`](#alignment/1)\n* [`spacing`](#spacing/1)\n* [`pinnedViews`](#pinnedViews/1)","ref":"lazyhgrid.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - LazyHGrid","doc":"See [`SwiftUI.LazyHGrid`](https://developer.apple.com/documentation/swiftui/LazyHGrid) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The alignment between rows. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     pinnedViews \n   \n   \n\n Pins section headers/footers. \n\n Discussion  See   PinnedScrollableViews  . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     rows \n   \n   \n\n Configured rows to fill with the child elements. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     spacing \n   \n   \n\n The spacing between rows. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"lazyhgrid.html#swiftui-documentation"},{"type":"extras","title":"LazyVGrid","doc":"# LazyVGrid\n<!-- tooltip support -->\n \n\n \n\n&lt;LazyVGrid&gt;\n\n \n\n \n   Grid that grows vertically. \n \n\n \n<!-- end tooltip support -->","ref":"lazyvgrid.html"},{"type":"extras","title":"Overview - LazyVGrid","doc":"Use the [`columns`](#columns/1) attribute to configure the presentation of the grid.\n\n```heex\n \n    <%= for i <- 1..50 do %>\n          Integer.to_string}><%= i %> \n    <% end %>\n \n```\nThere are 3 types of grid item:\n* `fixed(size, spacing, alignment)`: creates a single column that takes up the specified amount of space.\n* `flexible(minimum, maximum, spacing, alignment)`: creates a single column that fills the available space.\n* `adaptive(minimum, maximum, spacing, alignment)`: fills the available space with as many columns as will fit.","ref":"lazyvgrid.html#overview"},{"type":"extras","title":"Attributes - LazyVGrid","doc":"* [`columns`](#columns/1)\n* [`alignment`](#alignment/1)\n* [`spacing`](#spacing/1)\n* [`pinnedViews`](#pinnedViews/1)","ref":"lazyvgrid.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - LazyVGrid","doc":"See [`SwiftUI.LazyVGrid`](https://developer.apple.com/documentation/swiftui/LazyVGrid) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The alignment between columns. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     columns \n   \n   \n\n Configured columns to fill with the child elements. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     pinnedViews \n   \n   \n\n Pins section headers/footers. \n\n Discussion  See   PinnedScrollableViews  . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     spacing \n   \n   \n\n The spacing between rows. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"lazyvgrid.html#swiftui-documentation"},{"type":"extras","title":"LazyHStack","doc":"# LazyHStack\n<!-- tooltip support -->\n \n\n \n\n&lt;LazyHStack&gt;\n\n \n\n \n   Horizontal stack that creates Views lazily. \n \n\n \n<!-- end tooltip support -->","ref":"lazyhstack.html"},{"type":"extras","title":"Overview - LazyHStack","doc":"Lazy stacks behave similar to their non-lazy counterparts.\nUse the [`pinnedViews`](#pinnedViews/1) attribute to pin section headers/footers when contained in a `ScrollView`.\n\n```heex\n \n     \n        <%= for i <- 1..50 do %>\n              Integer.to_string} font=\"largeTitle\"><%= i %> \n        <% end %>\n     \n \n```","ref":"lazyhstack.html#overview"},{"type":"extras","title":"Attributes - LazyHStack","doc":"* [`alignment`](#alignment/1)\n* [`spacing`](#spacing/1)\n* [`pinnedViews`](#pinnedViews/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The vertical alignment of views within the stack. Defaults to center-aligned. \n\n Discussion  See   VerticalAlignment  . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     pinnedViews \n   \n   \n\n Pins section headers/footers. \n\n Discussion  See   PinnedScrollableViews  . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     spacing \n   \n   \n\n The spacing between views in the stack. If not provided, the stack uses the system spacing. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"lazyhstack.html#attributes"},{"type":"extras","title":"LazyVStack","doc":"# LazyVStack\n<!-- tooltip support -->\n \n\n \n\n&lt;LazyVStack&gt;\n\n \n\n \n   Vertical stack that creates Views lazily. \n \n\n \n<!-- end tooltip support -->","ref":"lazyvstack.html"},{"type":"extras","title":"Overview - LazyVStack","doc":"Lazy stacks behave similar to their non-lazy counterparts.\nUse the [`pinnedViews`](#pinnedViews/1) attribute to pin section headers/footers when contained in a `ScrollView`.\n\n```heex\n \n     \n        <%= for i <- 1..50 do %>\n              Integer.to_string} font=\"largeTitle\"><%= i %> \n        <% end %>\n     \n \n```","ref":"lazyvstack.html#overview"},{"type":"extras","title":"Attributes - LazyVStack","doc":"* [`alignment`](#alignment/1)\n* [`spacing`](#spacing/1)\n* [`pinnedViews`](#pinnedViews/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The horizontal alignment of views within the stack. Defaults to center-aligned. \n\n Discussion  See   VerticalAlignment  . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     pinnedViews \n   \n   \n\n Pins section headers/footers. \n\n Discussion  See   PinnedScrollableViews  . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     spacing \n   \n   \n\n The spacing between views in the stack. If not provided, the stack uses the system spacing. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"lazyvstack.html#attributes"},{"type":"extras","title":"Link","doc":"# Link\n<!-- tooltip support -->\n \n\n \n\n&lt;Link&gt;\n\n \n\n \n   Opens a URL when tapped. \n \n\n \n<!-- end tooltip support -->","ref":"link.html"},{"type":"extras","title":"Overview - Link","doc":"Provide a [`destination`](#destination/1) and label content to create a [` `](link.html#Link/1).\n\n```heex\n \n    Go to  LiveView Native \n \n```","ref":"link.html#overview"},{"type":"extras","title":"Attributes - Link","doc":"* [`destination`](#destination/1)","ref":"link.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - Link","doc":"See [`SwiftUI.Link`](https://developer.apple.com/documentation/swiftui/Link) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     destination \n   \n   \n\n A valid URL to open when tapped. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"link.html#swiftui-documentation"},{"type":"extras","title":"ShareLink","doc":"# ShareLink\n<!-- tooltip support -->\n \n\n \n\n&lt;ShareLink&gt;\n\n \n\n \n   Opens a system share sheet when tapped. \n \n\n \n<!-- end tooltip support -->","ref":"sharelink.html"},{"type":"extras","title":"Overview - ShareLink","doc":"Provide an [`item`](#item/1) or list of [`items`](#items/1) to share.\n\n```heex\n \n```\nUse a `SharePreview` element to override the title, image, and icon for an item.\n\n```heex\n \n     \n         \n         \n     \n \n```\nUse a JSON-encoded list of [`items`](#items/1) to share multiple values. Set the `item` attribute of each `SharePreview` to connect it to the correct item.\n\n```heex\n \n     \n         \n         \n     \n     \n         \n         \n     \n     \n         \n         \n     \n \n```","ref":"sharelink.html#overview"},{"type":"extras","title":"Attributes - ShareLink","doc":"* [`subject`](#subject/1)\n* [`message`](#message/1)\n* [`items`](#items/1)\n* [`item`](#item/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     item \n   \n   \n\n A string to share. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     message \n   \n   \n\n The description to use when sharing to a service with a message field. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     subject \n   \n   \n\n The title to use when sharing to a service with a subject field. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"sharelink.html#attributes"},{"type":"extras","title":"TextFieldLink","doc":"# TextFieldLink\n<!-- tooltip support -->\n \n\n \n\n&lt;TextFieldLink&gt;\n\n \n\n \n   A form element that requests text input on Apple Watch. \n \n\n \n<!-- end tooltip support -->","ref":"textfieldlink.html"},{"type":"extras","title":"Overview - TextFieldLink","doc":"This element displays a button that, when tapped, opens a dialogue for inputting text.\n\n```heex\n \n    What's your favorite color?\n \n```","ref":"textfieldlink.html#overview"},{"type":"extras","title":"Attributes - TextFieldLink","doc":"* [`prompt`](#prompt/1)\n* `value`\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     prompt \n   \n   \n\n Describes the reason for requesting text input. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"textfieldlink.html#attributes"},{"type":"extras","title":"Menu","doc":"# Menu\n<!-- tooltip support -->\n \n\n \n\n&lt;Menu&gt;\n\n \n\n \n   Tappable element that expands to reveal a list of options. \n \n\n \n<!-- end tooltip support -->","ref":"menu.html"},{"type":"extras","title":"Overview - Menu","doc":"Provide the `content` and `label` children to create a menu.\n\n```heex\n \n     \n        Edit Actions\n     \n     \n         Arrange \n         Update \n         Remove \n     \n \n```\nMenus can be nested by including another [` `](menu.html#Menu/1) in the `content`.","ref":"menu.html#overview"},{"type":"extras","title":"Children - Menu","doc":"* `label` - Describes the content of the menu.\n* `content` - Elements displayed when expanded.","ref":"menu.html#children"},{"type":"extras","title":"SwiftUI Documentation - Menu","doc":"See [`SwiftUI.Menu`](https://developer.apple.com/documentation/swiftui/Menu) for more details on this View.","ref":"menu.html#swiftui-documentation"},{"type":"extras","title":"ColorPicker","doc":"# ColorPicker\n<!-- tooltip support -->\n \n\n \n\n&lt;ColorPicker&gt;\n\n \n\n \n   Presents a system color picker when tapped. \n \n\n \n<!-- end tooltip support -->","ref":"colorpicker.html"},{"type":"extras","title":"Overview - ColorPicker","doc":"The color is stored as a map with the keys `r`, `g`, `b`, and optionally `a`.\n\n```heex\n \n    Favorite Color\n \n```","ref":"colorpicker.html#overview"},{"type":"extras","title":"Attributes - ColorPicker","doc":"[`supportsOpacity`](#supportsOpacity/1)","ref":"colorpicker.html#attributes"},{"type":"extras","title":"Bindings - ColorPicker","doc":"* [`selection`](#selection/1)","ref":"colorpicker.html#bindings"},{"type":"extras","title":"SwiftUI Documentation - ColorPicker","doc":"See [`SwiftUI.ColorPicker`](https://developer.apple.com/documentation/swiftui/ColorPicker) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     selection \n   \n   \n\n The currently selected color value. \n\n Discussion  The color is stored as a map with the keys  r ,  g ,  b , and optionally  a . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     supportsOpacity \n   \n   \n\n Enables the selection of transparent colors. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"colorpicker.html#swiftui-documentation"},{"type":"extras","title":"DatePicker","doc":"# DatePicker\n<!-- tooltip support -->\n \n\n \n\n&lt;DatePicker&gt;\n\n \n\n \n   A control that lets the user pick a date. \n \n\n \n<!-- end tooltip support -->","ref":"datepicker.html"},{"type":"extras","title":"Overview - DatePicker","doc":"The value of this control is an Elixir-style ISO 8601 date or datetime string (i.e., the result of `DateTime.to_iso8601`).\n\n```heex\n \n     Pick a date \n \n```\nChildren of the `DatePicker` element are used as the label for the control.","ref":"datepicker.html#overview"},{"type":"extras","title":"Specifying a Date Range - DatePicker","doc":"You can optionally specify a start and/or end date to limit the selectable range of the date picker.","ref":"datepicker.html#specifying-a-date-range"},{"type":"extras","title":"Attributes - DatePicker","doc":"* `selection`\n* [`start`](#start/1)\n* [`end`](#end/1)\n* [`displayed-components`](#displayed-components/1)","ref":"datepicker.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - DatePicker","doc":"See [`SwiftUI.DatePicker`](https://developer.apple.com/documentation/swiftui/DatePicker) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     displayed-components \n   \n   \n\n Which components of the date to display in the picker. Defaults to all. \n\n Discussion  Possible values:    hourAndMinute    date   \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     end \n   \n   \n\n The end date (inclusive) of the valid date range. Encoded as an ISO 8601 date or datetime string. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     start \n   \n   \n\n The start date (inclusive) of the valid date range. Encoded as an ISO 8601 date or datetime string. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"datepicker.html#swiftui-documentation"},{"type":"extras","title":"MultiDatePicker","doc":"# MultiDatePicker\n<!-- tooltip support -->\n \n\n \n\n&lt;MultiDatePicker&gt;\n\n \n\n \n   A control that allows the user to pick multiple dates (not datetimes). \n \n\n \n<!-- end tooltip support -->","ref":"multidatepicker.html"},{"type":"extras","title":"Overview - MultiDatePicker","doc":"```heex\n \n     Pick as many dates as you like! \n \n```\nThe element’s children are used as the control’s label.\nThe value is a list of date strings of the form “yyyy-MM-dd”.","ref":"multidatepicker.html#overview"},{"type":"extras","title":"Attributes - MultiDatePicker","doc":"* `selection`\n* [`start`](#start/1)\n* [`end`](#end/1)","ref":"multidatepicker.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - MultiDatePicker","doc":"See [`SwiftUI.MultiDatePicker`](https://developer.apple.com/documentation/swiftui/MultiDatePicker) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     end \n   \n   \n\n The end date () of the picker’s range. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     start \n   \n   \n\n The start date (inclusive) of the picker’s range. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"multidatepicker.html#swiftui-documentation"},{"type":"extras","title":"Picker","doc":"# Picker\n<!-- tooltip support -->\n \n\n \n\n&lt;Picker&gt;\n\n \n\n \n   A control that picks one of multiple values. \n \n\n \n<!-- end tooltip support -->","ref":"picker.html"},{"type":"extras","title":"Overview - Picker","doc":"The value of a picker is the value of the `TagModifier` for the selected option.\nUse the `content` children to specify the options for the picker, and the `label` children to provide a label.\n\n```heex\n \n     Transportation \n     \n         Car \n         Bus \n         Tram \n     \n \n```","ref":"picker.html#overview"},{"type":"extras","title":"Attributes - Picker","doc":"* `selection`","ref":"picker.html#attributes"},{"type":"extras","title":"Children - Picker","doc":"* `content`\n* `label`","ref":"picker.html#children"},{"type":"extras","title":"SwiftUI Documentation - Picker","doc":"See [`SwiftUI.Picker`](https://developer.apple.com/documentation/swiftui/Picker) for more details on this View.","ref":"picker.html#swiftui-documentation"},{"type":"extras","title":"HSplitView","doc":"# HSplitView\n<!-- tooltip support -->\n \n\n \n\n&lt;HSplitView&gt;\n\n \n\n \n   Container with resizable splits between elements. \n \n\n \n<!-- end tooltip support -->","ref":"hsplitview.html"},{"type":"extras","title":"Overview - HSplitView","doc":"Each element in the container will be in a separate resizable section.\nIf the element does not take up all available space, the section will only be able to shrink.\n\n```heex\n \n     \n     \n \n```","ref":"hsplitview.html#overview"},{"type":"extras","title":"SwiftUI Documentation - HSplitView","doc":"See [`SwiftUI.HSplitView`](https://developer.apple.com/documentation/swiftui/HSplitView) for more details on this View.","ref":"hsplitview.html#swiftui-documentation"},{"type":"extras","title":"NavigationLink","doc":"# NavigationLink\n<!-- tooltip support -->\n \n\n \n\n&lt;NavigationLink&gt;\n\n \n\n \n   A control users can tap to navigate to another live view. \n \n\n \n<!-- end tooltip support -->","ref":"navigationlink.html"},{"type":"extras","title":"Overview - NavigationLink","doc":"This only has an effect if the [`LiveSessionConfiguration`](livesessionconfiguration.html#LiveSessionConfiguration/1) was configured with navigation enabled.\n\n```heex\n \n     More Information \n \n```","ref":"navigationlink.html#overview"},{"type":"extras","title":"Attributes - NavigationLink","doc":"* [`destination`](#destination/1)\n* `disabled`","ref":"navigationlink.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - NavigationLink","doc":"See [`SwiftUI.NavigationLink`](https://developer.apple.com/documentation/swiftui/NavigationLink) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     destination \n   \n   \n\n The URL of the destination live view, relative to the current live view’s URL. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"navigationlink.html#swiftui-documentation"},{"type":"extras","title":"TabView","doc":"# TabView\n<!-- tooltip support -->\n \n\n \n\n&lt;TabView&gt;\n\n \n\n \n   Container that presents content on separate pages. \n \n\n \n<!-- end tooltip support -->","ref":"tabview.html"},{"type":"extras","title":"Overview - TabView","doc":"Each child element will become its own tab.\n\n```heex\n \n     \n     \n     \n \n```\nThe icon shown in the index view can be configured with the `TabItemModifier` modifier.","ref":"tabview.html#overview"},{"type":"extras","title":"Bindings - TabView","doc":"* [`selection`](#selection/1)","ref":"tabview.html#bindings"},{"type":"extras","title":"SwiftUI Documentation - TabView","doc":"See [`SwiftUI.TabView`](https://developer.apple.com/documentation/swiftui/TabView) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     selection \n   \n   \n\n Synchronizes the selected tab with the server. \n\n Discussion  Use the  TagModifier  modifier to set the selection value for a given tab. \n\n   \n \n\n\n<!-- end attribute list -->","ref":"tabview.html#swiftui-documentation"},{"type":"extras","title":"VSplitView","doc":"# VSplitView\n<!-- tooltip support -->\n \n\n \n\n&lt;VSplitView&gt;\n\n \n\n \n   Container with resizable splits between elements. \n \n\n \n<!-- end tooltip support -->","ref":"vsplitview.html"},{"type":"extras","title":"Overview - VSplitView","doc":"Each element in the container will be in a separate resizable section.\nIf the element does not take up all available space, the section will only be able to shrink.\n\n```heex\n \n     \n     \n \n```","ref":"vsplitview.html#overview"},{"type":"extras","title":"SwiftUI Documentation - VSplitView","doc":"See [`SwiftUI.VSplitView`](https://developer.apple.com/documentation/swiftui/VSplitView) for more details on this View.","ref":"vsplitview.html#swiftui-documentation"},{"type":"extras","title":"ScrollView","doc":"# ScrollView\n<!-- tooltip support -->\n \n\n \n\n&lt;ScrollView&gt;\n\n \n\n \n   A view that lets it contents be scrolled if larger than the available space. \n \n\n \n<!-- end tooltip support -->","ref":"scrollview.html"},{"type":"extras","title":"Overview - ScrollView","doc":"```heex\n \n     \n        <%= for color <- @colors %>\n             \n        <% end %>\n     \n \n```","ref":"scrollview.html#overview"},{"type":"extras","title":"Attributes - ScrollView","doc":"* [`axes`](#axes/1)\n* [`showsIndicators`](#showsIndicators/1)\n* [`scrollPosition`](#scrollPosition/1)\n* [`scrollPositionAnchor`](#scrollPositionAnchor/1)","ref":"scrollview.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - ScrollView","doc":"See [`SwiftUI.ScrollView`](https://developer.apple.com/documentation/swiftui/ScrollView) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     axes \n   \n   \n\n Which axes this view is scrollable along (defaults to vertical). \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     scrollPosition \n   \n   \n\n When the scroll view appears, and whenever this attribute changes, it will scroll to the view with the corresponding  id  attribute. \n\n Discussion  The   scrollPositionAnchor   attribute governs where in the scroll view the target will be positioned. \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     scrollPositionAnchor \n   \n   \n\n Where in the scroll view the view that is being scrolled to is positioned. \n\n Discussion  For example, specifying  top  will scroll the target to be at the top of the scroll view.\nSee   UnitPoint   for how values can be specified. \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     showsIndicators \n   \n   \n\n Whether the scroll indicators are shown (defaults to true). \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"scrollview.html#swiftui-documentation"},{"type":"extras","title":"Spacer","doc":"# Spacer\n<!-- tooltip support -->\n \n\n \n\n&lt;Spacer&gt;\n\n \n\n \n   A view that expands to provide space between other views. \n \n\n \n<!-- end tooltip support -->","ref":"spacer.html"},{"type":"extras","title":"Overview - Spacer","doc":"```heex\n \n     First \n     \n     Second \n \n```\nWithin horizontal and vertical stacks, the spacer only grows along the stack’s axis. Otherwise, the spacer grows in both axes.","ref":"spacer.html#overview"},{"type":"extras","title":"Attributes - Spacer","doc":"* [`minLength`](#minLength/1)","ref":"spacer.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - Spacer","doc":"See [`SwiftUI.Spacer`](https://developer.apple.com/documentation/swiftui/Spacer) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     minLength \n   \n   \n\n The minimum size of the spacer. If not provided, the minimum length is the system spacing. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"spacer.html#swiftui-documentation"},{"type":"extras","title":"Shape","doc":"# Shape\n<!-- tooltip support -->\n \n\n \n\nShape\n\n \n\n \n   A view that displays the a shape. \n \n\n \n<!-- end tooltip support -->","ref":"shape.html"},{"type":"extras","title":"Overview - Shape","doc":"This view isn’t used directly as an element. Instead, use the shape itself (e.g., ` `).","ref":"shape.html#overview"},{"type":"extras","title":"Attributes - Shape","doc":"* `fillColor`\n* `strokeColor`","ref":"shape.html#attributes"},{"type":"extras","title":"ViewThatFits","doc":"# ViewThatFits\n<!-- tooltip support -->\n \n\n \n\n&lt;ViewThatFits&gt;\n\n \n\n \n   Chooses the first child that fits in the available space. \n \n\n \n<!-- end tooltip support -->","ref":"viewthatfits.html"},{"type":"extras","title":"Overview - ViewThatFits","doc":"Child elements are evaluated in order, and the first child that fits in the available space along [`axes`](#axes/1) is displayed.\n\n```heex\n \n     Long text content ...  \n     \n \n```\nIn the above example, if the text content is too large to fit on screen the icon will be displayed instead.","ref":"viewthatfits.html#overview"},{"type":"extras","title":"Attributes - ViewThatFits","doc":"* [`axes`](#axes/1)","ref":"viewthatfits.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - ViewThatFits","doc":"See [`SwiftUI.ViewThatFits`](https://developer.apple.com/documentation/swiftui/ViewThatFits) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     axes \n   \n   \n\n The axes to check each child’s size along. Defaults to  all . \n\n Discussion  See   Axis.Set   \n\n   \n \n\n\n<!-- end attribute list -->","ref":"viewthatfits.html#swiftui-documentation"},{"type":"extras","title":"HStack","doc":"# HStack\n<!-- tooltip support -->\n \n\n \n\n&lt;HStack&gt;\n\n \n\n \n   Container that lays out its children in a horizontal line. \n \n\n \n<!-- end tooltip support -->","ref":"hstack.html"},{"type":"extras","title":"Overview - HStack","doc":"```heex\n \n     Leading \n     \n     Trailing \n \n```","ref":"hstack.html#overview"},{"type":"extras","title":"Attributes - HStack","doc":"* [`alignment`](#alignment/1)\n* [`spacing`](#spacing/1)","ref":"hstack.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - HStack","doc":"See [`SwiftUI.HStack`](https://developer.apple.com/documentation/swiftui/HStack) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The vertical alignment of views within the stack. Defaults to center-aligned. \n\n Discussion  See   VerticalAlignment  . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     spacing \n   \n   \n\n The spacing between views in the stack. If not provided, the stack uses the system spacing. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"hstack.html#swiftui-documentation"},{"type":"extras","title":"VStack","doc":"# VStack\n<!-- tooltip support -->\n \n\n \n\n&lt;VStack&gt;\n\n \n\n \n   Container that lays out its children in a vertical line. \n \n\n \n<!-- end tooltip support -->","ref":"vstack.html"},{"type":"extras","title":"Overview - VStack","doc":"```heex\n \n     Top \n     Bottom \n \n```","ref":"vstack.html#overview"},{"type":"extras","title":"Attributes - VStack","doc":"* [`alignment`](#alignment/1)\n* [`spacing`](#spacing/1)","ref":"vstack.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - VStack","doc":"See [`SwiftUI.VStack`](https://developer.apple.com/documentation/swiftui/VStack) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The horizontal alignment of views within the stack. Defaults to center-aligned. \n\n Discussion  See   HorizontalAlignment   \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     spacing \n   \n   \n\n The spacing between views in the stack. If not provided, the stack uses the system spacing. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"vstack.html#swiftui-documentation"},{"type":"extras","title":"ZStack","doc":"# ZStack\n<!-- tooltip support -->\n \n\n \n\n&lt;ZStack&gt;\n\n \n\n \n   A container that lays out elements on top of each other, back to front. \n \n\n \n<!-- end tooltip support -->","ref":"zstack.html"},{"type":"extras","title":"Overview - ZStack","doc":"```heex\n \n     Back \n     Front \n \n```","ref":"zstack.html#overview"},{"type":"extras","title":"Attributes - ZStack","doc":"* [`alignment`](#alignment/1)","ref":"zstack.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - ZStack","doc":"See [`SwiftUI.ZStack`](https://developer.apple.com/documentation/swiftui/ZStack) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     alignment \n   \n   \n\n The alignment in both axes of views within the stack. Defaults to center-aligned. \n\n Discussion  See   Alignment  . \n\n   \n \n\n\n<!-- end attribute list -->","ref":"zstack.html#swiftui-documentation"},{"type":"extras","title":"Label","doc":"# Label\n<!-- tooltip support -->\n \n\n \n\n&lt;Label&gt;\n\n \n\n \n   A title and icon pair. \n \n\n \n<!-- end tooltip support -->","ref":"label.html"},{"type":"extras","title":"Overview - Label","doc":"Use the `title` and `icon` children to create a label.\n\n```heex\n \n     John Doe \n     \n \n```\nWhen using a symbol as the icon, use the [`systemImage`](#systemImage/1) attribute.\n\n```heex\n \n     John Doe \n \n```","ref":"label.html#overview"},{"type":"extras","title":"Attributes - Label","doc":"* [`systemImage`](#systemImage/1)","ref":"label.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - Label","doc":"See [`SwiftUI.Label`](https://developer.apple.com/documentation/swiftui/Label) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     systemImage \n   \n   \n\n A symbol to use for the  icon . \n\n Discussion  This attribute takes precedence over the  icon  child.\nThis is equivalent to the  systemName  attribute on  Image . \n\n   \n \n\n\n<!-- end attribute list -->","ref":"label.html#swiftui-documentation"},{"type":"extras","title":"SecureField","doc":"# SecureField\n<!-- tooltip support -->\n \n\n \n\n&lt;SecureField&gt;\n\n \n\n \n   A form element for entering private text. \n \n\n \n<!-- end tooltip support -->","ref":"securefield.html"},{"type":"extras","title":"Overview - SecureField","doc":"This element is similar to [` `](textfield.html#TextField/1) but for secure text, such as passwords.\n\n```heex\n \n    Password\n \n```","ref":"securefield.html#overview"},{"type":"extras","title":"Attributes - SecureField","doc":"* `TextFieldProtocol/text`\n* `TextFieldProtocol/prompt`","ref":"securefield.html#attributes"},{"type":"extras","title":"Events - SecureField","doc":"* [`focusEvent`](#focusEvent/1)\n* [`blurEvent`](#blurEvent/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     blurEvent \n   \n   \n\n Sends an event when the field loses focus. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     focusEvent \n   \n   \n\n Sends an event when the field gains focus. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"securefield.html#events"},{"type":"extras","title":"Text","doc":"# Text\n<!-- tooltip support -->\n \n\n \n\n&lt;Text&gt;\n\n \n\n \n   Displays text. \n \n\n \n<!-- end tooltip support -->","ref":"text.html"},{"type":"extras","title":"Overview - Text","doc":"There are a number of modes for displaying text.","ref":"text.html#overview"},{"type":"extras","title":"Raw Strings - Text","doc":"Using text content or the `verbatim` attribute will display the given string.\n\n```heex\n Hello \n \n```","ref":"text.html#raw-strings"},{"type":"extras","title":"Dates - Text","doc":"Provide an ISO 8601 date (with optional time) in the `date` attribute, and optionally a [`Text.DateStyle`](swiftui/text/datestyle.html#Text.DateStyle/1) in the `dateStyle` attribute. Valid date styles are `date` (default), `time`, `relative`, `offset`, and `timer`. The displayed date is formatted with the user’s locale.\n\n```heex\n \n```","ref":"text.html#dates"},{"type":"extras","title":"Date Ranges - Text","doc":"Displays a localized date range between the given ISO 8601-formatted `dateStart` and `dateEnd`.\n\n```heex\n \n```","ref":"text.html#date-ranges"},{"type":"extras","title":"Markdown - Text","doc":"The value of the `markdown` attribute is parsed as Markdown and displayed. Only inline Markdown formatting is shown.\n\n```heex\n \n```","ref":"text.html#markdown"},{"type":"extras","title":"Formatted Values - Text","doc":"A value should provided in the `value` attribute, or in the inner text of the element. The value is formatted according to the `format` attribute:\n* `dateTime`: The `value` is an ISO 8601 date (with optional time).\n* `url`: The value is a URL.\n* `iso8601`: The `value` is an ISO 8601 date (with optional time).\n* `number`: The value is a `Double`. Shown in a localized number format.\n* `percent`: The value is a `Double`.\n* `currency`: The value is a `Double` and is shown as a localized currency value using the currency specified in the `currencyCode` attribute.\n* `name`: The value is a string interpreted as a person’s name. The `nameStyle` attribute determines the format of the name and may be `short`, `medium` (default), `long`, or `abbreviated`.\n\n```heex\n \n \n```","ref":"text.html#formatted-values"},{"type":"extras","title":"Formatting Text - Text","doc":"Use text modifiers to customize the appearance of text.\n\n```elixir\n\"large-bold\" do\n    font(.largeTitle)\n    bold()\nend\n```\n\n```heex\n \n    Hello, world!\n \n```","ref":"text.html#formatting-text"},{"type":"extras","title":"Nesting Elements - Text","doc":"Certain elements may be nested within a [` `](text.html#Text/1).\n* [` `](text.html#Text/1): Text elements can be nested to adjust the formatting for only particular parts of the text.\n* [` `](link.html#Link/1): Allows tappable links to be included in text.\n* `Image`: Embeds images in the text.\n\n```heex\n \n      \n     \n    Check out this thing I made:  mysite.com \n \n```","ref":"text.html#nesting-elements"},{"type":"extras","title":"Attributes - Text","doc":"* `verbatim`\n* `markdown`\n* `date`\n* `dateStart`\n* `dateEnd`\n* `value`\n* `format`\n* `currencyCode`\n* `nameStyle`\n* `dateStyle`","ref":"text.html#attributes"},{"type":"extras","title":"SwiftUI Documentation - Text","doc":"See [`SwiftUI.Text`](https://developer.apple.com/documentation/swiftui/Text) for more details on this View.","ref":"text.html#swiftui-documentation"},{"type":"extras","title":"TextEditor","doc":"# TextEditor\n<!-- tooltip support -->\n \n\n \n\n&lt;TextEditor&gt;\n\n \n\n \n   A multi-line, long-form text editor. \n \n\n \n<!-- end tooltip support -->","ref":"texteditor.html"},{"type":"extras","title":"Overview - TextEditor","doc":"```heex\n \n```","ref":"texteditor.html#overview"},{"type":"extras","title":"Events - TextEditor","doc":"* [`focusEvent`](#focusEvent/1)\n* [`blurEvent`](#blurEvent/1)","ref":"texteditor.html#events"},{"type":"extras","title":"SwiftUI Documentation - TextEditor","doc":"See [`SwiftUI.TextEditor`](https://developer.apple.com/documentation/swiftui/TextEditor) for more details on this View.\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     blurEvent \n   \n   \n\n An event that fires when the text editor is unfocused. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     focusEvent \n   \n   \n\n An event that fires when the text editor is focused. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"texteditor.html#swiftui-documentation"},{"type":"extras","title":"TextField","doc":"# TextField\n<!-- tooltip support -->\n \n\n \n\n&lt;TextField&gt;\n\n \n\n \n   A form element for entering text. \n \n\n \n<!-- end tooltip support -->","ref":"textfield.html"},{"type":"extras","title":"Overview - TextField","doc":"Any children of the field will be used as the label.\n\n```heex\n \n    First Name\n \n```\nYou can style the label by using elements inside.\n\n```heex\n \n     Last Name \n \n```","ref":"textfield.html#overview"},{"type":"extras","title":"Input Configuration - TextField","doc":"Use modifiers to configure how text is input.\n\n```elixir\n\"search-field\" do\n  autocorrectDisabled(true)\n  textInputAutocapitalization(.words)\n  keyboardType(.webSearch)\n  submitLabel(.search)\nend\n```\n\n```heex\n \n    Enter Search Text\n \n```","ref":"textfield.html#input-configuration"},{"type":"extras","title":"Formatting Values - TextField","doc":"Use the [`phx-focus`](#phx-focus/1) attribute to input values such as numbers and URLs.\n\n```heex\n \n     \n        Enter Amount\n     \n\n     \n        Enter Bank Address\n     \n \n```","ref":"textfield.html#formatting-values"},{"type":"extras","title":"Secure Input - TextField","doc":"To input private text, such as a password, use [` `](securefield.html#SecureField/1).","ref":"textfield.html#secure-input"},{"type":"extras","title":"Attributes - TextField","doc":"* `text`\n* [`phx-focus`](#phx-focus/1)\n* [`currencyCode`](#currencyCode/1)\n* [`nameStyle`](#nameStyle/1)\n* `TextFieldProtocol/axis`\n* `TextFieldProtocol/prompt`","ref":"textfield.html#attributes"},{"type":"extras","title":"Events - TextField","doc":"* [`focusEvent`](#focusEvent/1)\n* [`blurEvent`](#blurEvent/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     blurEvent \n   \n   \n\n\n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     currencyCode \n   \n   \n\n The currency code for the locale. \n\n Discussion  Example currency codes include  USD ,  EUR , and  JPY . \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     focusEvent \n   \n   \n\n\n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     phx-focus \n   \n   \n\n Possible values: \n\n Discussion    date-time    url    iso8601    number    percent    currency    name   \n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     nameStyle \n   \n   \n\n A type used to format a person’s name with a style appropriate for the given locale. \n\n Discussion  Possible values:    short    medium    long    abbreviated   \n\n   \n \n\n\n<!-- end attribute list -->","ref":"textfield.html#events"},{"type":"extras","title":"TextFieldProtocol","doc":"","ref":"textfieldprotocol.html"},{"type":"extras","title":"ToolbarItem","doc":"# ToolbarItem\n<!-- tooltip support -->\n \n\n \n\n&lt;ToolbarItem&gt;\n\n \n\n \n   Toolbar element for placing items. \n \n\n \n<!-- end tooltip support -->","ref":"toolbaritem.html"},{"type":"extras","title":"Overview - ToolbarItem","doc":"Optionally specify a [`placement`](#placement/1) to reposition the element.\n\n```heex\n \n     Delete \n \n```","ref":"toolbaritem.html#overview"},{"type":"extras","title":"Customizable Items - ToolbarItem","doc":"A customizable toolbar is a toolbar modifier with an `id`.\n\n```elixir\ntoolbar(id: \"unique-toolbar-id\", content: :my_toolbar_content)\n```\nSet the `id` attribute to a unique value on each customizable item.\n\n```heex\n \n    ...\n \n```\nTo prevent customization of an item in a customizable toolbar, set the [`customizationBehavior`](customizabletoolbaritem/customizationbehavior.html#customizationBehavior/1) attribute to `disabled`.\n\n```heex\n \n    ...\n \n```\nThe default visibility and options can be configured with the [`defaultVisibility`](customizabletoolbaritem/defaultvisibility.html#defaultVisibility/1) and [`alwaysAvailable`](customizabletoolbaritem/alwaysavailable.html#alwaysAvailable/1) attributes.\n\n```heex\n \n    ...\n \n```","ref":"toolbaritem.html#customizable-items"},{"type":"extras","title":"Attributes - ToolbarItem","doc":"* [`placement`](#placement/1)\n* [`id`](customizabletoolbaritem/id.html#id/1)\n* [`defaultVisibility`](customizabletoolbaritem/defaultvisibility.html#defaultVisibility/1)\n* [`alwaysAvailable`](customizabletoolbaritem/alwaysavailable.html#alwaysAvailable/1)\n* [`customizationBehavior`](customizabletoolbaritem/customizationbehavior.html#customizationBehavior/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     placement \n   \n   \n\n The position of this item in the toolbar. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"toolbaritem.html#attributes"},{"type":"extras","title":"ToolbarItemGroup","doc":"# ToolbarItemGroup\n<!-- tooltip support -->\n \n\n \n\n&lt;ToolbarItemGroup&gt;\n\n \n\n \n   Toolbar element for placing multiple items. \n \n\n \n<!-- end tooltip support -->","ref":"toolbaritemgroup.html"},{"type":"extras","title":"Overview - ToolbarItemGroup","doc":"Optionally specify a [`placement`](#placement/1) to reposition the elements.\n\n```heex\n \n     Delete \n     Destroy \n     Eradicate \n \n```","ref":"toolbaritemgroup.html#overview"},{"type":"extras","title":"Attributes - ToolbarItemGroup","doc":"* [`placement`](#placement/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     placement \n   \n   \n\n The position of this group in the toolbar. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"toolbaritemgroup.html#attributes"},{"type":"extras","title":"ToolbarTitleMenu","doc":"# ToolbarTitleMenu\n<!-- tooltip support -->\n \n\n \n\n&lt;ToolbarTitleMenu&gt;\n\n \n\n \n   Toolbar element that opens a menu when the navigation title is tapped. \n \n\n \n<!-- end tooltip support -->","ref":"toolbartitlemenu.html"},{"type":"extras","title":"Overview - ToolbarTitleMenu","doc":"On iOS, the menu can be opened by tapping the inline navigation bar title.\n\n```heex\n \n     Edit \n     Save \n     Open \n \n```","ref":"toolbartitlemenu.html#overview"},{"type":"extras","title":"Slider","doc":"# Slider\n<!-- tooltip support -->\n \n\n \n\n&lt;Slider&gt;\n\n \n\n \n   A form element for selecting a value within a range. \n \n\n \n<!-- end tooltip support -->","ref":"slider.html"},{"type":"extras","title":"Overview - Slider","doc":"By default, sliders choose values in the range 0-1.\n\n```heex\n \n```\nUse [`lowerBound`](#lowerBound/1) and [`upperBound`](#upperBound/1) to specify the range of possible values.\n\n```heex\n \n```\nUse the [`step`](#step/1) attribute to set the distance between valid values.\n\n```heex\n \n```\nCustomize the appearance of the slider with the children `label`, `minimum-value-label` and `maximum-value-label`.\n\n```heex\n \n     Percent Completed \n     0% \n     100% \n \n```","ref":"slider.html#overview"},{"type":"extras","title":"Attributes - Slider","doc":"* `value`\n* [`lowerBound`](#lowerBound/1)\n* [`upperBound`](#upperBound/1)\n* [`step`](#step/1)","ref":"slider.html#attributes"},{"type":"extras","title":"Children - Slider","doc":"* `label`\n* `minimumValueLabel`\n* `maximumValueLabel`\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     lowerBound \n   \n   \n\n The lowest allowed value. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     step \n   \n   \n\n The distance between allowed values. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     upperBound \n   \n   \n\n The highest allowed value. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"slider.html#children"},{"type":"extras","title":"Stepper","doc":"# Stepper\n<!-- tooltip support -->\n \n\n \n\n&lt;Stepper&gt;\n\n \n\n \n   A form element for incrementing/decrementing a value in a range. \n \n\n \n<!-- end tooltip support -->","ref":"stepper.html"},{"type":"extras","title":"Overview - Stepper","doc":"This element displays buttons for incrementing/decrementing a value by a [`step`](#step/1) amount.\n\n```heex\n \n    Attendees\n \n```\nUse [`lowerBound`](#lowerBound/1) and [`upperBound`](#upperBound/1) to limit the value. The [`step`](#step/1) attribute customizes the amount the value changes.\n\n```heex\n \n    Attendees\n \n```","ref":"stepper.html#overview"},{"type":"extras","title":"Attributes - Stepper","doc":"* `value`\n* [`step`](#step/1)\n* [`lowerBound`](#lowerBound/1)\n* [`upperBound`](#upperBound/1)\n\n\n<!-- attribute list -->\n# References\n\n \n   \n     \n        \n       Link to this reference \n     \n     lowerBound \n   \n   \n\n The lowest allowed value. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     step \n   \n   \n\n The amount to increment/decrement the value by. \n\n\n\n   \n \n \n   \n     \n        \n       Link to this reference \n     \n     upperBound \n   \n   \n\n The highest allowed value. \n\n\n\n   \n \n\n\n<!-- end attribute list -->","ref":"stepper.html#attributes"},{"type":"extras","title":"Toggle","doc":"# Toggle\n<!-- tooltip support -->\n \n\n \n\n&lt;Toggle&gt;\n\n \n\n \n   A form element that controls a boolean value. \n \n\n \n<!-- end tooltip support -->","ref":"toggle.html"},{"type":"extras","title":"Overview - Toggle","doc":"Add elements within the toggle to provide a label.\n\n```heex\n \n    Lights On\n \n```","ref":"toggle.html#overview"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}